package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.agraham.ioio.B4AIOIOBT _yoyo = null;
public static anywheresoftware.b4a.agraham.ioio.B4AIOIOBT.B4ASpiMasterBT _spi = null;
public static int[] _slavepins = null;
public static Object[] _slavemodes = null;
public static byte[] _wbuffer = null;
public static byte[] _rbuffer = null;
public static byte[] _wbuffera = null;
public static byte[] _wbuffercmd = null;
public static byte[] _rbuffercmd = null;
public static byte[] _rbufferb = null;
public static byte[] _rbufferc = null;
public static byte[] _rbufferd = null;
public static byte[] _rbuffere = null;
public static byte[] _rbufferf = null;
public static byte[] _rbufferg = null;
public static byte[] _rbufferh = null;
public static byte[] _rbufferi = null;
public static byte[] _rbufferj = null;
public static byte[] _rbufferk = null;
public static byte[] _rbufferl = null;
public static byte[] _rbufferm = null;
public static byte[] _rbuffern = null;
public static byte[] _rbuffero = null;
public static byte[] _rbufferp = null;
public static float[] _rbuffera = null;
public static float _i = 0f;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static int _hauteur_ecran_pix = 0;
public static int _largeur_ecran_pix = 0;
public static float _scale_ecran = 0f;
public static anywheresoftware.b4a.keywords.LayoutValues _lv = null;
public static anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper _rect1 = null;
public static int _origine = 0;
public static int _ppga = 0;
public static int _ppha = 0;
public static int _hpaa = 0;
public static int _lpa = 0;
public static float _nbpts = 0f;
public static float _freqnum = 0f;
public static float _factdilh = 0f;
public static boolean _sautaff = false;
public static float _minbdtc = 0f;
public static float _maxbdtc = 0f;
public static float _timer1interval = 0f;
public static int _couleur_de_fond = 0;
public static int _couleur_touches_1 = 0;
public static int _couleur_touches_2 = 0;
public static int _couleur_txt_touches = 0;
public static float _scaletextsize = 0f;
public static boolean _wifion = false;
public static int _couleur_ascan = 0;
public static int _largeur_trace_ascan = 0;
public static float _position_p_gauche = 0f;
public static float _position_p_haut = 0f;
public static float _hauteur_p_ascan = 0f;
public static float _largeur_p_ascan = 0f;
public static int _hf = 0;
public static float _gainc = 0f;
public static float _delayc = 0f;
public static float _scalec = 0f;
public static float _voltagec = 0f;
public static int _tfrequencyc = 0;
public static float _prfc = 0f;
public static int _rt = 0;
public static float _seuil = 0f;
public static int _filterc = 0;
public static String _answer = "";
public static long _memtime = 0L;
public static float _prfaff = 0f;
public static boolean _infocomp = false;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _canvasgraph = null;
public anywheresoftware.b4a.objects.ButtonWrapper _b2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _b1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _b3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _b4 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _b5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _b6 = null;
public static int[] _clr = null;
public anywheresoftware.b4a.objects.drawable.GradientDrawable _gdpressed = null;
public static int[] _clrp = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.PathWrapper _path1 = null;
public wifi.MLwifi _wifi = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.objects.drawable.GradientDrawable _gdwenabled = null;
anywheresoftware.b4a.objects.drawable.GradientDrawable _gdwpressed = null;
anywheresoftware.b4a.objects.drawable.StateListDrawable _stdgradient = null;
anywheresoftware.b4a.objects.drawable.StateListDrawable _stdgradient2 = null;
anywheresoftware.b4a.objects.drawable.StateListDrawable _stdgradient3 = null;
anywheresoftware.b4a.objects.drawable.StateListDrawable _stdgradient4 = null;
anywheresoftware.b4a.objects.drawable.StateListDrawable _stdgradient5 = null;
anywheresoftware.b4a.objects.drawable.StateListDrawable _stdgradient6 = null;
anywheresoftware.b4a.objects.drawable.StateListDrawable _stdgradienttxt = null;
 //BA.debugLineNum = 120;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)'Runs whe";
 //BA.debugLineNum = 124;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 125;BA.debugLine="YOYO.Initialize(True) '<------------------------";
_yoyo.Initialize(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 127;BA.debugLine="YOYO.WaitForConnect()";
_yoyo.WaitForConnect();
 //BA.debugLineNum = 128;BA.debugLine="spi=YOYO.OpenSpiMaster(10, spi.IP_PULL_UP, 11, s";
_spi.setObject((ioio.lib.api.SpiMaster)(_yoyo.OpenSpiMaster((int) (10),_spi.IP_PULL_UP,(int) (11),_spi.OP_NORMAL,(int) (12),_spi.OP_NORMAL,_slavepins,_slavemodes,_spi.RATE_333K,anywheresoftware.b4a.keywords.Common.False,anywheresoftware.b4a.keywords.Common.True)));
 };
 //BA.debugLineNum = 131;BA.debugLine="wifion=wifi.isWifiConnected";
_wifion = mostCurrent._wifi.isWifiConnected(processBA);
 //BA.debugLineNum = 132;BA.debugLine="If wifion=True Then";
if (_wifion==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 133;BA.debugLine="wifi.EnableWifi(False)";
mostCurrent._wifi.EnableWifi(processBA,anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 140;BA.debugLine="dac(1,0) 'for initilize dac module";
_dac((int) (1),(int) (0));
 //BA.debugLineNum = 142;BA.debugLine="PRF(prfc)";
_prf(_prfc);
 //BA.debugLineNum = 143;BA.debugLine="gain(gainc)";
_gain(_gainc);
 //BA.debugLineNum = 144;BA.debugLine="delay(delayc)";
_delay(_delayc);
 //BA.debugLineNum = 145;BA.debugLine="display_scale(scalec)";
_display_scale(_scalec);
 //BA.debugLineNum = 146;BA.debugLine="Transmitter_voltage(voltagec)";
_transmitter_voltage(_voltagec);
 //BA.debugLineNum = 147;BA.debugLine="Transmitter_frequency(tfrequencyc)";
_transmitter_frequency(_tfrequencyc);
 //BA.debugLineNum = 148;BA.debugLine="Transmission_mode(RT)";
_transmission_mode(_rt);
 //BA.debugLineNum = 151;BA.debugLine="echascan(8000)'operating time of the converter An";
_echascan((float) (8000));
 //BA.debugLineNum = 153;BA.debugLine="echostart(0,10000,50)";
_echostart((float) (0),(float) (10000),(int) (50));
 //BA.debugLineNum = 155;BA.debugLine="Filter(filterc)";
_filter(_filterc);
 //BA.debugLineNum = 161;BA.debugLine="hauteur_ecran_pix= Activity.Height";
_hauteur_ecran_pix = mostCurrent._activity.getHeight();
 //BA.debugLineNum = 162;BA.debugLine="largeur_ecran_pix = Activity.Width";
_largeur_ecran_pix = mostCurrent._activity.getWidth();
 //BA.debugLineNum = 163;BA.debugLine="Activity.LoadLayout(\"Main1\")";
mostCurrent._activity.LoadLayout("Main1",mostCurrent.activityBA);
 //BA.debugLineNum = 164;BA.debugLine="PPGA = largeur_ecran_pix * position_P_gauche/100";
_ppga = (int) (_largeur_ecran_pix*_position_p_gauche/(double)100);
 //BA.debugLineNum = 165;BA.debugLine="PPHA = hauteur_ecran_pix * position_P_haut/100";
_ppha = (int) (_hauteur_ecran_pix*_position_p_haut/(double)100);
 //BA.debugLineNum = 166;BA.debugLine="HPAA = hauteur_ecran_pix * hauteur_P_ascan/100";
_hpaa = (int) (_hauteur_ecran_pix*_hauteur_p_ascan/(double)100);
 //BA.debugLineNum = 167;BA.debugLine="LPA = largeur_ecran_pix * largeur_P_ascan/100";
_lpa = (int) (_largeur_ecran_pix*_largeur_p_ascan/(double)100);
 //BA.debugLineNum = 168;BA.debugLine="PPGA = largeur_ecran_pix-(LPA+PPGA)";
_ppga = (int) (_largeur_ecran_pix-(_lpa+_ppga));
 //BA.debugLineNum = 172;BA.debugLine="path1.Initialize(PPGA,PPHA)";
mostCurrent._path1.Initialize((float) (_ppga),(float) (_ppha));
 //BA.debugLineNum = 173;BA.debugLine="path1.Lineto(PPGA+LPA,PPHA)";
mostCurrent._path1.LineTo((float) (_ppga+_lpa),(float) (_ppha));
 //BA.debugLineNum = 174;BA.debugLine="path1.Lineto(PPGA+LPA,PPHA+HPAA+1)";
mostCurrent._path1.LineTo((float) (_ppga+_lpa),(float) (_ppha+_hpaa+1));
 //BA.debugLineNum = 175;BA.debugLine="path1.Lineto(PPGA,PPHA+HPAA+1)";
mostCurrent._path1.LineTo((float) (_ppga),(float) (_ppha+_hpaa+1));
 //BA.debugLineNum = 176;BA.debugLine="path1.Lineto(PPGA,PPHA)";
mostCurrent._path1.LineTo((float) (_ppga),(float) (_ppha));
 //BA.debugLineNum = 180;BA.debugLine="Dim gdwEnabled As GradientDrawable";
_gdwenabled = new anywheresoftware.b4a.objects.drawable.GradientDrawable();
 //BA.debugLineNum = 181;BA.debugLine="gdwEnabled.Initialize(\"TOP_BOTTOM\",clr)";
_gdwenabled.Initialize(BA.getEnumFromString(android.graphics.drawable.GradientDrawable.Orientation.class,"TOP_BOTTOM"),_clr);
 //BA.debugLineNum = 182;BA.debugLine="gdwEnabled.CornerRadius = 5";
_gdwenabled.setCornerRadius((float) (5));
 //BA.debugLineNum = 183;BA.debugLine="Dim gdwPressed As GradientDrawable";
_gdwpressed = new anywheresoftware.b4a.objects.drawable.GradientDrawable();
 //BA.debugLineNum = 184;BA.debugLine="gdwPressed.Initialize(\"LEFT_RIGHT\",clrp)";
_gdwpressed.Initialize(BA.getEnumFromString(android.graphics.drawable.GradientDrawable.Orientation.class,"LEFT_RIGHT"),_clrp);
 //BA.debugLineNum = 185;BA.debugLine="gdwPressed.CornerRadius = 7";
_gdwpressed.setCornerRadius((float) (7));
 //BA.debugLineNum = 186;BA.debugLine="Dim stdGradient As StateListDrawable";
_stdgradient = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
 //BA.debugLineNum = 187;BA.debugLine="stdGradient.Initialize";
_stdgradient.Initialize();
 //BA.debugLineNum = 188;BA.debugLine="stdGradient.AddState2(Array As Int(stdGradient";
_stdgradient.AddState2(new int[]{_stdgradient.State_Enabled,(int) (-_stdgradient.State_Pressed)},(android.graphics.drawable.Drawable)(_gdwenabled.getObject()));
 //BA.debugLineNum = 189;BA.debugLine="stdGradient.AddState(stdGradient.State_Pressed";
_stdgradient.AddState(_stdgradient.State_Pressed,(android.graphics.drawable.Drawable)(_gdwpressed.getObject()));
 //BA.debugLineNum = 190;BA.debugLine="Dim stdGradient2 As StateListDrawable";
_stdgradient2 = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
 //BA.debugLineNum = 191;BA.debugLine="stdGradient2.Initialize";
_stdgradient2.Initialize();
 //BA.debugLineNum = 192;BA.debugLine="stdGradient2.AddState2(Array As Int(stdGradien";
_stdgradient2.AddState2(new int[]{_stdgradient2.State_Enabled,(int) (-_stdgradient2.State_Pressed)},(android.graphics.drawable.Drawable)(_gdwenabled.getObject()));
 //BA.debugLineNum = 193;BA.debugLine="stdGradient2.AddState(stdGradient2.State_Press";
_stdgradient2.AddState(_stdgradient2.State_Pressed,(android.graphics.drawable.Drawable)(_gdwpressed.getObject()));
 //BA.debugLineNum = 194;BA.debugLine="Dim stdGradient3 As StateListDrawable";
_stdgradient3 = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
 //BA.debugLineNum = 195;BA.debugLine="stdGradient3.Initialize";
_stdgradient3.Initialize();
 //BA.debugLineNum = 196;BA.debugLine="stdGradient3.AddState2(Array As Int(stdGradien";
_stdgradient3.AddState2(new int[]{_stdgradient3.State_Enabled,(int) (-_stdgradient3.State_Pressed)},(android.graphics.drawable.Drawable)(_gdwenabled.getObject()));
 //BA.debugLineNum = 197;BA.debugLine="stdGradient3.AddState(stdGradient3.State_Press";
_stdgradient3.AddState(_stdgradient3.State_Pressed,(android.graphics.drawable.Drawable)(_gdwpressed.getObject()));
 //BA.debugLineNum = 198;BA.debugLine="Dim stdGradient4 As StateListDrawable";
_stdgradient4 = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
 //BA.debugLineNum = 199;BA.debugLine="stdGradient4.Initialize";
_stdgradient4.Initialize();
 //BA.debugLineNum = 200;BA.debugLine="stdGradient4.AddState2(Array As Int(stdGradien";
_stdgradient4.AddState2(new int[]{_stdgradient4.State_Enabled,(int) (-_stdgradient4.State_Pressed)},(android.graphics.drawable.Drawable)(_gdwenabled.getObject()));
 //BA.debugLineNum = 201;BA.debugLine="stdGradient4.AddState(stdGradient4.State_Press";
_stdgradient4.AddState(_stdgradient4.State_Pressed,(android.graphics.drawable.Drawable)(_gdwpressed.getObject()));
 //BA.debugLineNum = 202;BA.debugLine="Dim stdGradient5 As StateListDrawable";
_stdgradient5 = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
 //BA.debugLineNum = 203;BA.debugLine="stdGradient5.Initialize";
_stdgradient5.Initialize();
 //BA.debugLineNum = 204;BA.debugLine="stdGradient5.AddState2(Array As Int(stdGradien";
_stdgradient5.AddState2(new int[]{_stdgradient5.State_Enabled,(int) (-_stdgradient5.State_Pressed)},(android.graphics.drawable.Drawable)(_gdwenabled.getObject()));
 //BA.debugLineNum = 205;BA.debugLine="stdGradient5.AddState(stdGradient5.State_Press";
_stdgradient5.AddState(_stdgradient5.State_Pressed,(android.graphics.drawable.Drawable)(_gdwpressed.getObject()));
 //BA.debugLineNum = 206;BA.debugLine="Dim stdGradient6 As StateListDrawable";
_stdgradient6 = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
 //BA.debugLineNum = 207;BA.debugLine="stdGradient6.Initialize";
_stdgradient6.Initialize();
 //BA.debugLineNum = 208;BA.debugLine="stdGradient6.AddState2(Array As Int(stdGradien";
_stdgradient6.AddState2(new int[]{_stdgradient6.State_Enabled,(int) (-_stdgradient6.State_Pressed)},(android.graphics.drawable.Drawable)(_gdwenabled.getObject()));
 //BA.debugLineNum = 209;BA.debugLine="stdGradient6.AddState(stdGradient6.State_Press";
_stdgradient6.AddState(_stdgradient6.State_Pressed,(android.graphics.drawable.Drawable)(_gdwpressed.getObject()));
 //BA.debugLineNum = 210;BA.debugLine="Dim stdGradienttxt As StateListDrawable";
_stdgradienttxt = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
 //BA.debugLineNum = 211;BA.debugLine="stdGradienttxt.Initialize";
_stdgradienttxt.Initialize();
 //BA.debugLineNum = 212;BA.debugLine="stdGradienttxt.AddState2(Array As Int(stdGradi";
_stdgradienttxt.AddState2(new int[]{_stdgradienttxt.State_Enabled,(int) (-_stdgradienttxt.State_Pressed)},(android.graphics.drawable.Drawable)(_gdwenabled.getObject()));
 //BA.debugLineNum = 213;BA.debugLine="stdGradienttxt.AddState(stdGradienttxt.State_P";
_stdgradienttxt.AddState(_stdgradienttxt.State_Pressed,(android.graphics.drawable.Drawable)(_gdwpressed.getObject()));
 //BA.debugLineNum = 215;BA.debugLine="rect1.Initialize(PPGA,PPHA,LPA+PPGA,PPHA+HPAA)";
_rect1.Initialize(_ppga,_ppha,(int) (_lpa+_ppga),(int) (_ppha+_hpaa));
 //BA.debugLineNum = 217;BA.debugLine="B1.Background=stdGradient :B2.Background= stdGra";
mostCurrent._b1.setBackground((android.graphics.drawable.Drawable)(_stdgradient.getObject()));
 //BA.debugLineNum = 217;BA.debugLine="B1.Background=stdGradient :B2.Background= stdGra";
mostCurrent._b2.setBackground((android.graphics.drawable.Drawable)(_stdgradient2.getObject()));
 //BA.debugLineNum = 217;BA.debugLine="B1.Background=stdGradient :B2.Background= stdGra";
mostCurrent._b3.setBackground((android.graphics.drawable.Drawable)(_stdgradient3.getObject()));
 //BA.debugLineNum = 217;BA.debugLine="B1.Background=stdGradient :B2.Background= stdGra";
mostCurrent._b4.setBackground((android.graphics.drawable.Drawable)(_stdgradient4.getObject()));
 //BA.debugLineNum = 217;BA.debugLine="B1.Background=stdGradient :B2.Background= stdGra";
mostCurrent._b5.setBackground((android.graphics.drawable.Drawable)(_stdgradient5.getObject()));
 //BA.debugLineNum = 217;BA.debugLine="B1.Background=stdGradient :B2.Background= stdGra";
mostCurrent._b6.setBackground((android.graphics.drawable.Drawable)(_stdgradient6.getObject()));
 //BA.debugLineNum = 218;BA.debugLine="B1.TextColor=couleur_txt_touches:B2.TextColor=co";
mostCurrent._b1.setTextColor(_couleur_txt_touches);
 //BA.debugLineNum = 218;BA.debugLine="B1.TextColor=couleur_txt_touches:B2.TextColor=co";
mostCurrent._b2.setTextColor(_couleur_txt_touches);
 //BA.debugLineNum = 218;BA.debugLine="B1.TextColor=couleur_txt_touches:B2.TextColor=co";
mostCurrent._b3.setTextColor(_couleur_txt_touches);
 //BA.debugLineNum = 218;BA.debugLine="B1.TextColor=couleur_txt_touches:B2.TextColor=co";
mostCurrent._b4.setTextColor(_couleur_txt_touches);
 //BA.debugLineNum = 218;BA.debugLine="B1.TextColor=couleur_txt_touches:B2.TextColor=co";
mostCurrent._b5.setTextColor(_couleur_txt_touches);
 //BA.debugLineNum = 218;BA.debugLine="B1.TextColor=couleur_txt_touches:B2.TextColor=co";
mostCurrent._b6.setTextColor(_couleur_txt_touches);
 //BA.debugLineNum = 222;BA.debugLine="CanvasGraph.Initialize(Activity)";
mostCurrent._canvasgraph.Initialize((android.view.View)(mostCurrent._activity.getObject()));
 //BA.debugLineNum = 224;BA.debugLine="lv = GetDeviceLayoutValues 'Screen scale 320 x 48";
_lv = anywheresoftware.b4a.keywords.Common.GetDeviceLayoutValues(mostCurrent.activityBA);
 //BA.debugLineNum = 225;BA.debugLine="Scale_ecran=lv.Scale";
_scale_ecran = _lv.Scale;
 //BA.debugLineNum = 226;BA.debugLine="B1.Text=\"Display and Transmission Mode\":B2.Text=\"";
mostCurrent._b1.setText((Object)("Display and Transmission Mode"));
 //BA.debugLineNum = 226;BA.debugLine="B1.Text=\"Display and Transmission Mode\":B2.Text=\"";
mostCurrent._b2.setText((Object)("Scale and Gain"));
 //BA.debugLineNum = 226;BA.debugLine="B1.Text=\"Display and Transmission Mode\":B2.Text=\"";
mostCurrent._b3.setText((Object)("Sampling Delay"));
 //BA.debugLineNum = 226;BA.debugLine="B1.Text=\"Display and Transmission Mode\":B2.Text=\"";
mostCurrent._b4.setText((Object)("Transmitter Frequency and Voltage"));
 //BA.debugLineNum = 226;BA.debugLine="B1.Text=\"Display and Transmission Mode\":B2.Text=\"";
mostCurrent._b5.setText((Object)("PRF"));
 //BA.debugLineNum = 226;BA.debugLine="B1.Text=\"Display and Transmission Mode\":B2.Text=\"";
mostCurrent._b6.setText((Object)("Filters"));
 //BA.debugLineNum = 227;BA.debugLine="B1.TextSize= scaletextsize:B2.TextSize= scaletext";
mostCurrent._b1.setTextSize(_scaletextsize);
 //BA.debugLineNum = 227;BA.debugLine="B1.TextSize= scaletextsize:B2.TextSize= scaletext";
mostCurrent._b2.setTextSize(_scaletextsize);
 //BA.debugLineNum = 227;BA.debugLine="B1.TextSize= scaletextsize:B2.TextSize= scaletext";
mostCurrent._b3.setTextSize(_scaletextsize);
 //BA.debugLineNum = 227;BA.debugLine="B1.TextSize= scaletextsize:B2.TextSize= scaletext";
mostCurrent._b4.setTextSize(_scaletextsize);
 //BA.debugLineNum = 227;BA.debugLine="B1.TextSize= scaletextsize:B2.TextSize= scaletext";
mostCurrent._b5.setTextSize(_scaletextsize);
 //BA.debugLineNum = 227;BA.debugLine="B1.TextSize= scaletextsize:B2.TextSize= scaletext";
mostCurrent._b6.setTextSize(_scaletextsize);
 //BA.debugLineNum = 231;BA.debugLine="timer1interval=20";
_timer1interval = (float) (20);
 //BA.debugLineNum = 232;BA.debugLine="timer1.Initialize(\"Timer1\", timer1interval)";
_timer1.Initialize(processBA,"Timer1",(long) (_timer1interval));
 //BA.debugLineNum = 233;BA.debugLine="timer1.Enabled = True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 234;BA.debugLine="memtime=DateTime.Now";
_memtime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 238;BA.debugLine="wBuffercmd(0)=Floor(nbpts/256) 'msb desactivé ave";
_wbuffercmd[(int) (0)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor(_nbpts/(double)256));
 //BA.debugLineNum = 239;BA.debugLine="wBuffercmd(1)=nbpts-Floor(nbpts/256)*256 'lsb";
_wbuffercmd[(int) (1)] = (byte) (_nbpts-anywheresoftware.b4a.keywords.Common.Floor(_nbpts/(double)256)*256);
 //BA.debugLineNum = 240;BA.debugLine="wBuffercmd(2)=4 'selection nbpts";
_wbuffercmd[(int) (2)] = (byte) (4);
 //BA.debugLineNum = 241;BA.debugLine="spi.WriteRead(0,wBuffercmd,3,3,rBuffercmd,0)";
_spi.WriteRead((int) (0),_wbuffercmd,(int) (3),(int) (3),_rbuffercmd,(int) (0));
 //BA.debugLineNum = 243;BA.debugLine="infocomp=True";
_infocomp = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 245;BA.debugLine="End Sub";
return "";
}
public static String  _b1_click() throws Exception{
String _lb = "";
anywheresoftware.b4a.objects.collections.List _lst = null;
int _choice = 0;
String _lb1 = "";
anywheresoftware.b4a.objects.collections.List _lst1 = null;
int _choice1 = 0;
String _lb2 = "";
anywheresoftware.b4a.objects.collections.List _lst2 = null;
int _choice2 = 0;
 //BA.debugLineNum = 672;BA.debugLine="Sub B1_Click 'Display type (hf=0=HF,=1=ASCAN DA) a";
 //BA.debugLineNum = 674;BA.debugLine="Dim lb As String";
_lb = "";
 //BA.debugLineNum = 675;BA.debugLine="Dim lst As List";
_lst = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 676;BA.debugLine="Dim choice As Int";
_choice = 0;
 //BA.debugLineNum = 677;BA.debugLine="lst.Initialize";
_lst.Initialize();
 //BA.debugLineNum = 679;BA.debugLine="lb=\"Which parameter do you want to modify ?\"";
_lb = "Which parameter do you want to modify ?";
 //BA.debugLineNum = 680;BA.debugLine="lst.add(\"Display type\")";
_lst.Add((Object)("Display type"));
 //BA.debugLineNum = 681;BA.debugLine="lst.add(\"Transmission mode\")";
_lst.Add((Object)("Transmission mode"));
 //BA.debugLineNum = 683;BA.debugLine="choice = InputList(lst, lb, choice)";
_choice = anywheresoftware.b4a.keywords.Common.InputList(_lst,_lb,_choice,mostCurrent.activityBA);
 //BA.debugLineNum = 685;BA.debugLine="If choice>=0 Then";
if (_choice>=0) { 
 //BA.debugLineNum = 687;BA.debugLine="Select Case choice";
switch (_choice) {
case 0: {
 //BA.debugLineNum = 690;BA.debugLine="Dim lb1 As String";
_lb1 = "";
 //BA.debugLineNum = 691;BA.debugLine="Dim lst1 As List";
_lst1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 692;BA.debugLine="Dim choice1 As Int";
_choice1 = 0;
 //BA.debugLineNum = 693;BA.debugLine="lst1.Initialize";
_lst1.Initialize();
 //BA.debugLineNum = 695;BA.debugLine="lst1.add(\"HF\")";
_lst1.Add((Object)("HF"));
 //BA.debugLineNum = 696;BA.debugLine="lst1.add(\"ASCAN\")";
_lst1.Add((Object)("ASCAN"));
 //BA.debugLineNum = 698;BA.debugLine="choice1 = InputList(lst1, lb1, hf)";
_choice1 = anywheresoftware.b4a.keywords.Common.InputList(_lst1,_lb1,_hf,mostCurrent.activityBA);
 //BA.debugLineNum = 700;BA.debugLine="If choice1>=0 Then";
if (_choice1>=0) { 
 //BA.debugLineNum = 702;BA.debugLine="Select Case choice1";
switch (_choice1) {
case 0: {
 //BA.debugLineNum = 705;BA.debugLine="hf=0";
_hf = (int) (0);
 break; }
case 1: {
 //BA.debugLineNum = 709;BA.debugLine="hf=1";
_hf = (int) (1);
 break; }
}
;
 };
 //BA.debugLineNum = 714;BA.debugLine="timer1_tick";
_timer1_tick();
 break; }
case 1: {
 //BA.debugLineNum = 718;BA.debugLine="Dim lb2 As String";
_lb2 = "";
 //BA.debugLineNum = 719;BA.debugLine="Dim lst2 As List";
_lst2 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 720;BA.debugLine="Dim choice2 As Int";
_choice2 = 0;
 //BA.debugLineNum = 721;BA.debugLine="lst2.Initialize";
_lst2.Initialize();
 //BA.debugLineNum = 723;BA.debugLine="lst2.add(\"Reflection\")";
_lst2.Add((Object)("Reflection"));
 //BA.debugLineNum = 724;BA.debugLine="lst2.add(\"Transmission\")";
_lst2.Add((Object)("Transmission"));
 //BA.debugLineNum = 726;BA.debugLine="choice2 = InputList(lst2, lb2, RT)";
_choice2 = anywheresoftware.b4a.keywords.Common.InputList(_lst2,_lb2,_rt,mostCurrent.activityBA);
 //BA.debugLineNum = 728;BA.debugLine="If choice2>=0 Then";
if (_choice2>=0) { 
 //BA.debugLineNum = 730;BA.debugLine="Select Case choice2";
switch (_choice2) {
case 0: {
 //BA.debugLineNum = 733;BA.debugLine="RT=0";
_rt = (int) (0);
 break; }
case 1: {
 //BA.debugLineNum = 737;BA.debugLine="RT=1";
_rt = (int) (1);
 break; }
}
;
 };
 //BA.debugLineNum = 742;BA.debugLine="Transmission_mode(RT)";
_transmission_mode(_rt);
 break; }
}
;
 };
 //BA.debugLineNum = 747;BA.debugLine="End Sub";
return "";
}
public static String  _b2_click() throws Exception{
String _lb = "";
anywheresoftware.b4a.objects.collections.List _lst = null;
int _choice = 0;
int _choix = 0;
 //BA.debugLineNum = 748;BA.debugLine="Sub B2_Click 'Scale (scalec in µs) and Gain";
 //BA.debugLineNum = 750;BA.debugLine="Dim lb As String";
_lb = "";
 //BA.debugLineNum = 751;BA.debugLine="Dim lst As List";
_lst = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 752;BA.debugLine="Dim choice As Int";
_choice = 0;
 //BA.debugLineNum = 753;BA.debugLine="Dim choix As Int =0";
_choix = (int) (0);
 //BA.debugLineNum = 754;BA.debugLine="lst.Initialize";
_lst.Initialize();
 //BA.debugLineNum = 756;BA.debugLine="lb=\"Which parameter do you want to modify ?\"";
_lb = "Which parameter do you want to modify ?";
 //BA.debugLineNum = 757;BA.debugLine="lst.add(\"Display scale\")";
_lst.Add((Object)("Display scale"));
 //BA.debugLineNum = 758;BA.debugLine="lst.add(\"Gain\")";
_lst.Add((Object)("Gain"));
 //BA.debugLineNum = 760;BA.debugLine="choice = InputList(lst, lb, choix)";
_choice = anywheresoftware.b4a.keywords.Common.InputList(_lst,_lb,_choix,mostCurrent.activityBA);
 //BA.debugLineNum = 762;BA.debugLine="If choice>=0 Then";
if (_choice>=0) { 
 //BA.debugLineNum = 764;BA.debugLine="Select Case choice";
switch (_choice) {
case 0: {
 //BA.debugLineNum = 767;BA.debugLine="answer = keyboard(1,\"Scale in µs\")";
_answer = _keyboard((int) (1),"Scale in µs");
 //BA.debugLineNum = 768;BA.debugLine="If answer <>\"\" And answer >=0 Then scalec = an";
if ((_answer).equals("") == false && (double)(Double.parseDouble(_answer))>=0) { 
_scalec = (float)(Double.parseDouble(_answer));};
 //BA.debugLineNum = 769;BA.debugLine="display_scale(scalec)";
_display_scale(_scalec);
 break; }
case 1: {
 //BA.debugLineNum = 774;BA.debugLine="answer = keyboard(1,\"Gain in dB\")";
_answer = _keyboard((int) (1),"Gain in dB");
 //BA.debugLineNum = 775;BA.debugLine="If answer <>\"\" And answer >=0 Then gainc = ans";
if ((_answer).equals("") == false && (double)(Double.parseDouble(_answer))>=0) { 
_gainc = (float)(Double.parseDouble(_answer));};
 //BA.debugLineNum = 776;BA.debugLine="gain(gainc)";
_gain(_gainc);
 break; }
}
;
 };
 //BA.debugLineNum = 782;BA.debugLine="End Sub";
return "";
}
public static String  _b3_click() throws Exception{
 //BA.debugLineNum = 783;BA.debugLine="Sub B3_Click 'Sampling delay (retardc en µs)";
 //BA.debugLineNum = 785;BA.debugLine="answer = keyboard(1,\"Sampling delay in µs\")";
_answer = _keyboard((int) (1),"Sampling delay in µs");
 //BA.debugLineNum = 786;BA.debugLine="If answer <>\"\" And answer >=0 Then delayc = an";
if ((_answer).equals("") == false && (double)(Double.parseDouble(_answer))>=0) { 
_delayc = (float)(Double.parseDouble(_answer));};
 //BA.debugLineNum = 788;BA.debugLine="delay(delayc)";
_delay(_delayc);
 //BA.debugLineNum = 790;BA.debugLine="End Sub";
return "";
}
public static String  _b4_click() throws Exception{
String _lb = "";
anywheresoftware.b4a.objects.collections.List _lst = null;
int _choice = 0;
int _choix = 0;
 //BA.debugLineNum = 791;BA.debugLine="Sub B4_Click 'Transmitter frequency and voltage";
 //BA.debugLineNum = 793;BA.debugLine="Dim lb As String";
_lb = "";
 //BA.debugLineNum = 794;BA.debugLine="Dim lst As List";
_lst = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 795;BA.debugLine="Dim choice As Int";
_choice = 0;
 //BA.debugLineNum = 796;BA.debugLine="Dim choix As Int =0";
_choix = (int) (0);
 //BA.debugLineNum = 797;BA.debugLine="lst.Initialize";
_lst.Initialize();
 //BA.debugLineNum = 799;BA.debugLine="lb=\"Which parameter do you want to modify ?\"";
_lb = "Which parameter do you want to modify ?";
 //BA.debugLineNum = 800;BA.debugLine="lst.add(\"Transmitter frequency\")";
_lst.Add((Object)("Transmitter frequency"));
 //BA.debugLineNum = 801;BA.debugLine="lst.add(\"Transmitter voltage\")";
_lst.Add((Object)("Transmitter voltage"));
 //BA.debugLineNum = 803;BA.debugLine="choice = InputList(lst, lb, choix)";
_choice = anywheresoftware.b4a.keywords.Common.InputList(_lst,_lb,_choix,mostCurrent.activityBA);
 //BA.debugLineNum = 805;BA.debugLine="If choice>=0 Then";
if (_choice>=0) { 
 //BA.debugLineNum = 807;BA.debugLine="Select Case choice";
switch (_choice) {
case 0: {
 //BA.debugLineNum = 810;BA.debugLine="answer = keyboard(1,\"Transmitter frequency in";
_answer = _keyboard((int) (1),"Transmitter frequency in MHz");
 //BA.debugLineNum = 811;BA.debugLine="If answer <>\"\" And answer >=0 Then tfrequencyc";
if ((_answer).equals("") == false && (double)(Double.parseDouble(_answer))>=0) { 
_tfrequencyc = (int)(Double.parseDouble(_answer));};
 //BA.debugLineNum = 812;BA.debugLine="Transmitter_frequency(tfrequencyc)";
_transmitter_frequency(_tfrequencyc);
 break; }
case 1: {
 //BA.debugLineNum = 816;BA.debugLine="answer = keyboard(1,\"Transmitter voltage\")";
_answer = _keyboard((int) (1),"Transmitter voltage");
 //BA.debugLineNum = 817;BA.debugLine="If answer <>\"\" And answer >=0 Then voltagec =";
if ((_answer).equals("") == false && (double)(Double.parseDouble(_answer))>=0) { 
_voltagec = (float)(Double.parseDouble(_answer));};
 //BA.debugLineNum = 818;BA.debugLine="Transmitter_voltage(voltagec)";
_transmitter_voltage(_voltagec);
 break; }
}
;
 };
 //BA.debugLineNum = 823;BA.debugLine="End Sub";
return "";
}
public static String  _b5_click() throws Exception{
 //BA.debugLineNum = 824;BA.debugLine="Sub B5_Click 'PRF";
 //BA.debugLineNum = 826;BA.debugLine="answer = keyboard(1,\"Frequency in Hz\")";
_answer = _keyboard((int) (1),"Frequency in Hz");
 //BA.debugLineNum = 827;BA.debugLine="If answer <>\"\" And answer >=0 Then prfc = answ";
if ((_answer).equals("") == false && (double)(Double.parseDouble(_answer))>=0) { 
_prfc = (float)(Double.parseDouble(_answer));};
 //BA.debugLineNum = 828;BA.debugLine="PRF(prfc)";
_prf(_prfc);
 //BA.debugLineNum = 830;BA.debugLine="End Sub";
return "";
}
public static String  _b6_click() throws Exception{
String _lb = "";
anywheresoftware.b4a.objects.collections.List _lst = null;
int _choice = 0;
 //BA.debugLineNum = 831;BA.debugLine="Sub B6_Click 'Filters";
 //BA.debugLineNum = 833;BA.debugLine="Dim lb As String";
_lb = "";
 //BA.debugLineNum = 834;BA.debugLine="Dim lst As List";
_lst = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 835;BA.debugLine="Dim choice As Int";
_choice = 0;
 //BA.debugLineNum = 836;BA.debugLine="lst.Initialize";
_lst.Initialize();
 //BA.debugLineNum = 838;BA.debugLine="lb=\"Select filter\"";
_lb = "Select filter";
 //BA.debugLineNum = 839;BA.debugLine="lst.add(\"1.25 MHz\")	'0";
_lst.Add((Object)("1.25 MHz"));
 //BA.debugLineNum = 840;BA.debugLine="lst.add(\"2.5 MHz\")	'1";
_lst.Add((Object)("2.5 MHz"));
 //BA.debugLineNum = 841;BA.debugLine="lst.add(\"5 MHz\")	'2";
_lst.Add((Object)("5 MHz"));
 //BA.debugLineNum = 842;BA.debugLine="lst.add(\"10 MHz\")	'3";
_lst.Add((Object)("10 MHz"));
 //BA.debugLineNum = 843;BA.debugLine="lst.add(\"BROADBAND\")	'4";
_lst.Add((Object)("BROADBAND"));
 //BA.debugLineNum = 845;BA.debugLine="choice = InputList(lst, lb, filterc)";
_choice = anywheresoftware.b4a.keywords.Common.InputList(_lst,_lb,_filterc,mostCurrent.activityBA);
 //BA.debugLineNum = 847;BA.debugLine="If choice >=0 Then";
if (_choice>=0) { 
 //BA.debugLineNum = 848;BA.debugLine="Select Case choice";
switch (_choice) {
case 0: {
 //BA.debugLineNum = 850;BA.debugLine="filterc=0";
_filterc = (int) (0);
 break; }
case 1: {
 //BA.debugLineNum = 852;BA.debugLine="filterc=1";
_filterc = (int) (1);
 break; }
case 2: {
 //BA.debugLineNum = 854;BA.debugLine="filterc=2";
_filterc = (int) (2);
 break; }
case 3: {
 //BA.debugLineNum = 856;BA.debugLine="filterc=3";
_filterc = (int) (3);
 break; }
case 4: {
 //BA.debugLineNum = 858;BA.debugLine="filterc=4";
_filterc = (int) (4);
 break; }
}
;
 };
 //BA.debugLineNum = 862;BA.debugLine="Filter(filterc)";
_filter(_filterc);
 //BA.debugLineNum = 864;BA.debugLine="End Sub";
return "";
}
public static String  _dac(int _madac,int _progdac) throws Exception{
 //BA.debugLineNum = 663;BA.debugLine="Sub dac(madac As Int,progdac As Int)";
 //BA.debugLineNum = 665;BA.debugLine="wBuffera(0)=madac+progdac*2";
_wbuffera[(int) (0)] = (byte) (_madac+_progdac*2);
 //BA.debugLineNum = 666;BA.debugLine="wBuffera(1)=11";
_wbuffera[(int) (1)] = (byte) (11);
 //BA.debugLineNum = 667;BA.debugLine="spi.WriteRead(0,wBuffera,2,2,rBufferl,1)";
_spi.WriteRead((int) (0),_wbuffera,(int) (2),(int) (2),_rbufferl,(int) (1));
 //BA.debugLineNum = 669;BA.debugLine="End Sub";
return "";
}
public static String  _delay(float _calculation_delay) throws Exception{
 //BA.debugLineNum = 541;BA.debugLine="Sub delay(calculation_delay As Float)";
 //BA.debugLineNum = 542;BA.debugLine="If delayc < 0 Then delayc = 0";
if (_delayc<0) { 
_delayc = (float) (0);};
 //BA.debugLineNum = 544;BA.debugLine="calculation_delay = delayc / 0.025 'pas de 25 n";
_calculation_delay = (float) (_delayc/(double)0.025);
 //BA.debugLineNum = 546;BA.debugLine="wBuffercmd(0)=Floor(calculation_delay/256) 'msb";
_wbuffercmd[(int) (0)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor(_calculation_delay/(double)256));
 //BA.debugLineNum = 547;BA.debugLine="wBuffercmd(1)=calculation_delay-Floor(calculati";
_wbuffercmd[(int) (1)] = (byte) (_calculation_delay-anywheresoftware.b4a.keywords.Common.Floor(_calculation_delay/(double)256)*256);
 //BA.debugLineNum = 548;BA.debugLine="wBuffercmd(2)=5 'selection retard";
_wbuffercmd[(int) (2)] = (byte) (5);
 //BA.debugLineNum = 549;BA.debugLine="spi.WriteRead(0,wBuffercmd,3,3,rBuffercmd,1)";
_spi.WriteRead((int) (0),_wbuffercmd,(int) (3),(int) (3),_rbuffercmd,(int) (1));
 //BA.debugLineNum = 551;BA.debugLine="End Sub";
return "";
}
public static String  _display_scale(float _calculation_scale) throws Exception{
float _nbechant = 0f;
float _c = 0f;
float _d = 0f;
float _e = 0f;
 //BA.debugLineNum = 552;BA.debugLine="Sub display_scale(calculation_scale As Float)";
 //BA.debugLineNum = 554;BA.debugLine="If calculation_scale < minbdtc Then scalec = minb";
if (_calculation_scale<_minbdtc) { 
_scalec = _minbdtc;};
 //BA.debugLineNum = 556;BA.debugLine="If calculation_scale > maxbdtc Then scalec = maxb";
if (_calculation_scale>_maxbdtc) { 
_scalec = _maxbdtc;};
 //BA.debugLineNum = 558;BA.debugLine="Dim nbechant As Float";
_nbechant = 0f;
 //BA.debugLineNum = 559;BA.debugLine="Dim c As Float";
_c = 0f;
 //BA.debugLineNum = 560;BA.debugLine="Dim d As Float";
_d = 0f;
 //BA.debugLineNum = 561;BA.debugLine="Dim e As Float";
_e = 0f;
 //BA.debugLineNum = 563;BA.debugLine="nbechant =scalec*10*freqnum";
_nbechant = (float) (_scalec*10*_freqnum);
 //BA.debugLineNum = 564;BA.debugLine="c = nbechant/nbpts";
_c = (float) (_nbechant/(double)_nbpts);
 //BA.debugLineNum = 565;BA.debugLine="d=Floor(c)'correction of the calculation of the";
_d = (float) (anywheresoftware.b4a.keywords.Common.Floor(_c));
 //BA.debugLineNum = 566;BA.debugLine="factcomp(d)'compression factor";
_factcomp((int) (_d));
 //BA.debugLineNum = 567;BA.debugLine="factdilh= ((d+1)/freqnum *nbpts)/(scalec*10) 'di";
_factdilh = (float) (((_d+1)/(double)_freqnum*_nbpts)/(double)(_scalec*10));
 //BA.debugLineNum = 569;BA.debugLine="wBuffera(0)=2";
_wbuffera[(int) (0)] = (byte) (2);
 //BA.debugLineNum = 570;BA.debugLine="spi.WriteRead(0,wBuffera,1,1,rBufferl,0)'get new";
_spi.WriteRead((int) (0),_wbuffera,(int) (1),(int) (1),_rbufferl,(int) (0));
 //BA.debugLineNum = 571;BA.debugLine="sautaff=True:origine=5 'avoid display jumps";
_sautaff = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 571;BA.debugLine="sautaff=True:origine=5 'avoid display jumps";
_origine = (int) (5);
 //BA.debugLineNum = 573;BA.debugLine="End Sub";
return "";
}
public static String  _echascan(float _consechascan) throws Exception{
 //BA.debugLineNum = 639;BA.debugLine="Sub echascan(consechascan As Float)";
 //BA.debugLineNum = 640;BA.debugLine="wBuffercmd(0)=Floor(consechascan/256) 'msb";
_wbuffercmd[(int) (0)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor(_consechascan/(double)256));
 //BA.debugLineNum = 641;BA.debugLine="wBuffercmd(1)=consechascan-Floor(consechascan/2";
_wbuffercmd[(int) (1)] = (byte) (_consechascan-anywheresoftware.b4a.keywords.Common.Floor(_consechascan/(double)256)*256);
 //BA.debugLineNum = 642;BA.debugLine="wBuffercmd(2)=10 'selection echascan";
_wbuffercmd[(int) (2)] = (byte) (10);
 //BA.debugLineNum = 643;BA.debugLine="spi.WriteRead(0,wBuffercmd,3,3,rBuffercmd,1)";
_spi.WriteRead((int) (0),_wbuffercmd,(int) (3),(int) (3),_rbuffercmd,(int) (1));
 //BA.debugLineNum = 645;BA.debugLine="End Sub";
return "";
}
public static String  _echostart(float _pos,float _duree,int _polarite) throws Exception{
 //BA.debugLineNum = 646;BA.debugLine="Sub echostart(pos As Float,duree As Float, polarit";
 //BA.debugLineNum = 650;BA.debugLine="wBuffera(0)=Floor(duree/256)";
_wbuffera[(int) (0)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor(_duree/(double)256));
 //BA.debugLineNum = 651;BA.debugLine="wBuffera(1)=duree-Floor(duree/256)*256";
_wbuffera[(int) (1)] = (byte) (_duree-anywheresoftware.b4a.keywords.Common.Floor(_duree/(double)256)*256);
 //BA.debugLineNum = 652;BA.debugLine="wBuffera(2)=Floor(pos/256) 'msb";
_wbuffera[(int) (2)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor(_pos/(double)256));
 //BA.debugLineNum = 653;BA.debugLine="wBuffera(3)=pos-Floor(pos/256)*256";
_wbuffera[(int) (3)] = (byte) (_pos-anywheresoftware.b4a.keywords.Common.Floor(_pos/(double)256)*256);
 //BA.debugLineNum = 654;BA.debugLine="wBuffera(4)=12";
_wbuffera[(int) (4)] = (byte) (12);
 //BA.debugLineNum = 655;BA.debugLine="spi.WriteRead(0,wBuffera,5,5,rBufferl,1)";
_spi.WriteRead((int) (0),_wbuffera,(int) (5),(int) (5),_rbufferl,(int) (1));
 //BA.debugLineNum = 657;BA.debugLine="wBuffera(0)=polarite";
_wbuffera[(int) (0)] = (byte) (_polarite);
 //BA.debugLineNum = 658;BA.debugLine="wBuffera(1)=13";
_wbuffera[(int) (1)] = (byte) (13);
 //BA.debugLineNum = 659;BA.debugLine="spi.WriteRead(0,wBuffera,2,2,rBufferl,1)'polarite";
_spi.WriteRead((int) (0),_wbuffera,(int) (2),(int) (2),_rbufferl,(int) (1));
 //BA.debugLineNum = 662;BA.debugLine="End Sub";
return "";
}
public static String  _factcomp(int _consfactcomp) throws Exception{
 //BA.debugLineNum = 574;BA.debugLine="Sub factcomp(consfactcomp As Int)";
 //BA.debugLineNum = 576;BA.debugLine="wBuffera(0)=consfactcomp";
_wbuffera[(int) (0)] = (byte) (_consfactcomp);
 //BA.debugLineNum = 577;BA.debugLine="wBuffera(1)=3";
_wbuffera[(int) (1)] = (byte) (3);
 //BA.debugLineNum = 578;BA.debugLine="spi.WriteRead(0,wBuffera,2,2,rBufferl,1)'compress";
_spi.WriteRead((int) (0),_wbuffera,(int) (2),(int) (2),_rbufferl,(int) (1));
 //BA.debugLineNum = 580;BA.debugLine="End Sub";
return "";
}
public static String  _filter(int _cfilterc) throws Exception{
 //BA.debugLineNum = 632;BA.debugLine="Sub Filter(cfilterc As Int)";
 //BA.debugLineNum = 634;BA.debugLine="wBuffercmd(0)=cfilterc	'selection filter 0/1/2/3";
_wbuffercmd[(int) (0)] = (byte) (_cfilterc);
 //BA.debugLineNum = 635;BA.debugLine="wBuffercmd(1)=14 'selection filter 0/1/2/3/4 lb";
_wbuffercmd[(int) (1)] = (byte) (14);
 //BA.debugLineNum = 636;BA.debugLine="spi.WriteRead(0,wBuffercmd,2,2,rBuffercmd,1)";
_spi.WriteRead((int) (0),_wbuffercmd,(int) (2),(int) (2),_rbuffercmd,(int) (1));
 //BA.debugLineNum = 638;BA.debugLine="End Sub";
return "";
}
public static String  _gain(float _calculation_gain) throws Exception{
 //BA.debugLineNum = 526;BA.debugLine="Sub gain(calculation_gain As Float)";
 //BA.debugLineNum = 528;BA.debugLine="If gainc > 80 Then gainc = 80	'maximum gain";
if (_gainc>80) { 
_gainc = (float) (80);};
 //BA.debugLineNum = 530;BA.debugLine="If gainc < 0 Then gainc = 0	'minimum gain";
if (_gainc<0) { 
_gainc = (float) (0);};
 //BA.debugLineNum = 533;BA.debugLine="calculation_gain = gainc*(875-65)/80+65";
_calculation_gain = (float) (_gainc*(875-65)/(double)80+65);
 //BA.debugLineNum = 535;BA.debugLine="wBuffercmd(0)=Floor(calculation_gain/256) 'msb";
_wbuffercmd[(int) (0)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor(_calculation_gain/(double)256));
 //BA.debugLineNum = 536;BA.debugLine="wBuffercmd(1)=calculation_gain-Floor(calculation";
_wbuffercmd[(int) (1)] = (byte) (_calculation_gain-anywheresoftware.b4a.keywords.Common.Floor(_calculation_gain/(double)256)*256);
 //BA.debugLineNum = 537;BA.debugLine="wBuffercmd(2)=0 'selection gain";
_wbuffercmd[(int) (2)] = (byte) (0);
 //BA.debugLineNum = 538;BA.debugLine="spi.WriteRead(0,wBuffercmd,3,3,rBuffercmd,1)";
_spi.WriteRead((int) (0),_wbuffercmd,(int) (3),(int) (3),_rbuffercmd,(int) (1));
 //BA.debugLineNum = 540;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 97;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 100;BA.debugLine="Dim CanvasGraph As Canvas";
mostCurrent._canvasgraph = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 101;BA.debugLine="Dim B2 As Button";
mostCurrent._b2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 102;BA.debugLine="Dim B1 As Button";
mostCurrent._b1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 103;BA.debugLine="Dim B3 As Button";
mostCurrent._b3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 104;BA.debugLine="Dim B4 As Button";
mostCurrent._b4 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 105;BA.debugLine="Dim B5 As Button";
mostCurrent._b5 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 106;BA.debugLine="Dim B6 As Button";
mostCurrent._b6 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 107;BA.debugLine="Dim clr(2) As Int	'???????????";
_clr = new int[(int) (2)];
;
 //BA.debugLineNum = 108;BA.debugLine="clr(0)=couleur_touches_1'????????";
_clr[(int) (0)] = _couleur_touches_1;
 //BA.debugLineNum = 109;BA.debugLine="clr(1)=couleur_touches_2'??????????";
_clr[(int) (1)] = _couleur_touches_2;
 //BA.debugLineNum = 110;BA.debugLine="Dim gdpressed As GradientDrawable";
mostCurrent._gdpressed = new anywheresoftware.b4a.objects.drawable.GradientDrawable();
 //BA.debugLineNum = 111;BA.debugLine="Dim clrp(2) As Int";
_clrp = new int[(int) (2)];
;
 //BA.debugLineNum = 112;BA.debugLine="clrp(0)=Colors.Red";
_clrp[(int) (0)] = anywheresoftware.b4a.keywords.Common.Colors.Red;
 //BA.debugLineNum = 113;BA.debugLine="clrp(1)=Colors.Magenta";
_clrp[(int) (1)] = anywheresoftware.b4a.keywords.Common.Colors.Magenta;
 //BA.debugLineNum = 114;BA.debugLine="gdpressed.Initialize(\"TOP_BOTTOM\", clrp)";
mostCurrent._gdpressed.Initialize(BA.getEnumFromString(android.graphics.drawable.GradientDrawable.Orientation.class,"TOP_BOTTOM"),_clrp);
 //BA.debugLineNum = 115;BA.debugLine="Dim path1 As Path";
mostCurrent._path1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.PathWrapper();
 //BA.debugLineNum = 116;BA.debugLine="Dim wifi As MLwifi";
mostCurrent._wifi = new wifi.MLwifi();
 //BA.debugLineNum = 118;BA.debugLine="End Sub";
return "";
}
public static String  _keyboard(int _input_type,String _text_to_be_displayed) throws Exception{
int _ret = 0;
anywheresoftware.b4a.agraham.dialogs.InputDialog _id = null;
 //BA.debugLineNum = 866;BA.debugLine="Sub keyboard(input_type As Int, text_to_be_display";
 //BA.debugLineNum = 868;BA.debugLine="Dim ret As Int";
_ret = 0;
 //BA.debugLineNum = 869;BA.debugLine="Dim Id As InputDialog";
_id = new anywheresoftware.b4a.agraham.dialogs.InputDialog();
 //BA.debugLineNum = 870;BA.debugLine="Select Case input_type";
switch (_input_type) {
case 0: {
 //BA.debugLineNum = 873;BA.debugLine="Id.InputType = Id.INPUT_TYPE_TEXT";
_id.setInputType(_id.INPUT_TYPE_TEXT);
 break; }
case 1: {
 //BA.debugLineNum = 875;BA.debugLine="Id.InputType = Id.INPUT_TYPE_DECIMAL_NUMBERS";
_id.setInputType(_id.INPUT_TYPE_DECIMAL_NUMBERS);
 break; }
case 2: {
 //BA.debugLineNum = 877;BA.debugLine="Id.InputType = Id.INPUT_TYPE_NUMBERS";
_id.setInputType(_id.INPUT_TYPE_NUMBERS);
 break; }
}
;
 //BA.debugLineNum = 880;BA.debugLine="Id.input = \"\"";
_id.setInput("");
 //BA.debugLineNum = 881;BA.debugLine="Id.Hint = text_to_be_displayed";
_id.setHint(_text_to_be_displayed);
 //BA.debugLineNum = 882;BA.debugLine="Id.HintColor = Colors.ARGB(196, 255, 140, 0)";
_id.setHintColor(anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (196),(int) (255),(int) (140),(int) (0)));
 //BA.debugLineNum = 883;BA.debugLine="ret = DialogResponse.CANCEL";
_ret = anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL;
 //BA.debugLineNum = 884;BA.debugLine="ret = Id.Show(text_to_be_displayed, \"US-SMART\", \"";
_ret = _id.Show(_text_to_be_displayed,"US-SMART","Validate","","Cancel",mostCurrent.activityBA,(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null));
 //BA.debugLineNum = 885;BA.debugLine="If ret=-2 Then Id.input=\"\"";
if (_ret==-2) { 
_id.setInput("");};
 //BA.debugLineNum = 886;BA.debugLine="Return Id.input";
if (true) return _id.getInput();
 //BA.debugLineNum = 888;BA.debugLine="End Sub";
return "";
}
public static String  _mygraphbt(int _nbech) throws Exception{
int _offset = 0;
int _j = 0;
 //BA.debugLineNum = 247;BA.debugLine="Sub MyGraphbt(nbech As Int)'Sampling";
 //BA.debugLineNum = 250;BA.debugLine="Dim offset As Int =2  'offset baseline";
_offset = (int) (2);
 //BA.debugLineNum = 252;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBuffer,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbuffer,(int) (64));
 //BA.debugLineNum = 253;BA.debugLine="For j=0 To 63";
{
final int step3 = 1;
final int limit3 = (int) (63);
for (_j = (int) (0) ; (step3 > 0 && _j <= limit3) || (step3 < 0 && _j >= limit3); _j = ((int)(0 + _j + step3)) ) {
 //BA.debugLineNum = 254;BA.debugLine="rBuffera(j)=Bit.And(rBuffer(j),0xFF)+offset";
_rbuffera[_j] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbuffer[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 257;BA.debugLine="If nbech=64 Then Return";
if (_nbech==64) { 
if (true) return "";};
 //BA.debugLineNum = 259;BA.debugLine="spi.WriteReadasync(1,wBuffera,0,64,rBufferb,64)";
_spi.WriteReadAsync((int) (1),_wbuffera,(int) (0),(int) (64),_rbufferb,(int) (64));
 //BA.debugLineNum = 260;BA.debugLine="For j=0 To 63";
{
final int step8 = 1;
final int limit8 = (int) (63);
for (_j = (int) (0) ; (step8 > 0 && _j <= limit8) || (step8 < 0 && _j >= limit8); _j = ((int)(0 + _j + step8)) ) {
 //BA.debugLineNum = 261;BA.debugLine="rBuffera(j+64)=Bit.And(rBufferb(j),0xFF)+offset";
_rbuffera[(int) (_j+64)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferb[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 264;BA.debugLine="If nbech=128 Then Return";
if (_nbech==128) { 
if (true) return "";};
 //BA.debugLineNum = 266;BA.debugLine="spi.WriteReadasync(1,wBuffercmd,0,64,rBufferc,64";
_spi.WriteReadAsync((int) (1),_wbuffercmd,(int) (0),(int) (64),_rbufferc,(int) (64));
 //BA.debugLineNum = 267;BA.debugLine="For j=0 To 63";
{
final int step13 = 1;
final int limit13 = (int) (63);
for (_j = (int) (0) ; (step13 > 0 && _j <= limit13) || (step13 < 0 && _j >= limit13); _j = ((int)(0 + _j + step13)) ) {
 //BA.debugLineNum = 268;BA.debugLine="rBuffera(j+128)=Bit.And(rBufferc(j),0xFF)+offset";
_rbuffera[(int) (_j+128)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferc[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 272;BA.debugLine="If nbech=192 Then Return";
if (_nbech==192) { 
if (true) return "";};
 //BA.debugLineNum = 275;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferd,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferd,(int) (64));
 //BA.debugLineNum = 276;BA.debugLine="For j=0 To 63";
{
final int step18 = 1;
final int limit18 = (int) (63);
for (_j = (int) (0) ; (step18 > 0 && _j <= limit18) || (step18 < 0 && _j >= limit18); _j = ((int)(0 + _j + step18)) ) {
 //BA.debugLineNum = 277;BA.debugLine="rBuffera(j+192)=Bit.And(rBufferd(j),0xFF)+offset";
_rbuffera[(int) (_j+192)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferd[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 280;BA.debugLine="If nbech=256 Then Return";
if (_nbech==256) { 
if (true) return "";};
 //BA.debugLineNum = 282;BA.debugLine="spi.WriteReadasync(1,wBuffer,64,64,rBuffere,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (64),(int) (64),_rbuffere,(int) (64));
 //BA.debugLineNum = 283;BA.debugLine="For j=0 To 63";
{
final int step23 = 1;
final int limit23 = (int) (63);
for (_j = (int) (0) ; (step23 > 0 && _j <= limit23) || (step23 < 0 && _j >= limit23); _j = ((int)(0 + _j + step23)) ) {
 //BA.debugLineNum = 284;BA.debugLine="rBuffera(j+256)=Bit.And(rBuffere(j),0xFF)+offset";
_rbuffera[(int) (_j+256)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbuffere[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 287;BA.debugLine="If nbech=320 Then Return";
if (_nbech==320) { 
if (true) return "";};
 //BA.debugLineNum = 289;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferf,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferf,(int) (64));
 //BA.debugLineNum = 290;BA.debugLine="For j=0 To 63";
{
final int step28 = 1;
final int limit28 = (int) (63);
for (_j = (int) (0) ; (step28 > 0 && _j <= limit28) || (step28 < 0 && _j >= limit28); _j = ((int)(0 + _j + step28)) ) {
 //BA.debugLineNum = 291;BA.debugLine="rBuffera(j+320)=Bit.And(rBufferf(j),0xFF)+offset";
_rbuffera[(int) (_j+320)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferf[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 294;BA.debugLine="If nbech=384 Then Return";
if (_nbech==384) { 
if (true) return "";};
 //BA.debugLineNum = 296;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferg,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferg,(int) (64));
 //BA.debugLineNum = 297;BA.debugLine="For j=0 To 63";
{
final int step33 = 1;
final int limit33 = (int) (63);
for (_j = (int) (0) ; (step33 > 0 && _j <= limit33) || (step33 < 0 && _j >= limit33); _j = ((int)(0 + _j + step33)) ) {
 //BA.debugLineNum = 298;BA.debugLine="rBuffera(j+384)=Bit.And(rBufferg(j),0xFF)+offset";
_rbuffera[(int) (_j+384)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferg[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 301;BA.debugLine="If nbech=448 Then Return";
if (_nbech==448) { 
if (true) return "";};
 //BA.debugLineNum = 303;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferh,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferh,(int) (64));
 //BA.debugLineNum = 304;BA.debugLine="For j=0 To 63";
{
final int step38 = 1;
final int limit38 = (int) (63);
for (_j = (int) (0) ; (step38 > 0 && _j <= limit38) || (step38 < 0 && _j >= limit38); _j = ((int)(0 + _j + step38)) ) {
 //BA.debugLineNum = 305;BA.debugLine="rBuffera(j+448)=Bit.And(rBufferh(j),0xFF)+offset";
_rbuffera[(int) (_j+448)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferh[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 308;BA.debugLine="If nbech=512 Then Return";
if (_nbech==512) { 
if (true) return "";};
 //BA.debugLineNum = 310;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferi,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferi,(int) (64));
 //BA.debugLineNum = 311;BA.debugLine="For j=0 To 63";
{
final int step43 = 1;
final int limit43 = (int) (63);
for (_j = (int) (0) ; (step43 > 0 && _j <= limit43) || (step43 < 0 && _j >= limit43); _j = ((int)(0 + _j + step43)) ) {
 //BA.debugLineNum = 312;BA.debugLine="rBuffera(j+512)=Bit.And(rBufferi(j),0xFF)+offset";
_rbuffera[(int) (_j+512)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferi[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 315;BA.debugLine="If nbech=576 Then Return";
if (_nbech==576) { 
if (true) return "";};
 //BA.debugLineNum = 317;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferj,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferj,(int) (64));
 //BA.debugLineNum = 318;BA.debugLine="For j=0 To 63";
{
final int step48 = 1;
final int limit48 = (int) (63);
for (_j = (int) (0) ; (step48 > 0 && _j <= limit48) || (step48 < 0 && _j >= limit48); _j = ((int)(0 + _j + step48)) ) {
 //BA.debugLineNum = 319;BA.debugLine="rBuffera(j+576)=Bit.And(rBufferj(j),0xFF)+offset";
_rbuffera[(int) (_j+576)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferj[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 322;BA.debugLine="If nbech=640 Then Return";
if (_nbech==640) { 
if (true) return "";};
 //BA.debugLineNum = 324;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferk,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferk,(int) (64));
 //BA.debugLineNum = 325;BA.debugLine="For j=0 To 63";
{
final int step53 = 1;
final int limit53 = (int) (63);
for (_j = (int) (0) ; (step53 > 0 && _j <= limit53) || (step53 < 0 && _j >= limit53); _j = ((int)(0 + _j + step53)) ) {
 //BA.debugLineNum = 326;BA.debugLine="rBuffera(j+640)=Bit.And(rBufferk(j),0xFF)+offset";
_rbuffera[(int) (_j+640)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferk[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 329;BA.debugLine="If nbech=704 Then Return";
if (_nbech==704) { 
if (true) return "";};
 //BA.debugLineNum = 331;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferl,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferl,(int) (64));
 //BA.debugLineNum = 332;BA.debugLine="For j=0 To 63";
{
final int step58 = 1;
final int limit58 = (int) (63);
for (_j = (int) (0) ; (step58 > 0 && _j <= limit58) || (step58 < 0 && _j >= limit58); _j = ((int)(0 + _j + step58)) ) {
 //BA.debugLineNum = 333;BA.debugLine="rBuffera(j+704)=Bit.And(rBufferl(j),0xFF)+offset";
_rbuffera[(int) (_j+704)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferl[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 336;BA.debugLine="If nbech=768 Then Return";
if (_nbech==768) { 
if (true) return "";};
 //BA.debugLineNum = 338;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferm,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferm,(int) (64));
 //BA.debugLineNum = 339;BA.debugLine="For j=0 To 63";
{
final int step63 = 1;
final int limit63 = (int) (63);
for (_j = (int) (0) ; (step63 > 0 && _j <= limit63) || (step63 < 0 && _j >= limit63); _j = ((int)(0 + _j + step63)) ) {
 //BA.debugLineNum = 340;BA.debugLine="rBuffera(j+768)=Bit.And(rBufferm(j),0xFF)+offset";
_rbuffera[(int) (_j+768)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferm[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 343;BA.debugLine="If nbech=832 Then Return";
if (_nbech==832) { 
if (true) return "";};
 //BA.debugLineNum = 345;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBuffern,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbuffern,(int) (64));
 //BA.debugLineNum = 346;BA.debugLine="For j=0 To 63";
{
final int step68 = 1;
final int limit68 = (int) (63);
for (_j = (int) (0) ; (step68 > 0 && _j <= limit68) || (step68 < 0 && _j >= limit68); _j = ((int)(0 + _j + step68)) ) {
 //BA.debugLineNum = 347;BA.debugLine="rBuffera(j+832)=Bit.And(rBuffern(j),0xFF)+offset";
_rbuffera[(int) (_j+832)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbuffern[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 350;BA.debugLine="If nbech=896 Then Return";
if (_nbech==896) { 
if (true) return "";};
 //BA.debugLineNum = 352;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBuffero,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbuffero,(int) (64));
 //BA.debugLineNum = 353;BA.debugLine="For j=0 To 63";
{
final int step73 = 1;
final int limit73 = (int) (63);
for (_j = (int) (0) ; (step73 > 0 && _j <= limit73) || (step73 < 0 && _j >= limit73); _j = ((int)(0 + _j + step73)) ) {
 //BA.debugLineNum = 354;BA.debugLine="rBuffera(j+896)=Bit.And(rBuffero(j),0xFF)+offset";
_rbuffera[(int) (_j+896)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbuffero[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 357;BA.debugLine="If nbech=960 Then Return";
if (_nbech==960) { 
if (true) return "";};
 //BA.debugLineNum = 359;BA.debugLine="spi.WriteReadasync(1,wBuffer,0,64,rBufferp,64)";
_spi.WriteReadAsync((int) (1),_wbuffer,(int) (0),(int) (64),_rbufferp,(int) (64));
 //BA.debugLineNum = 360;BA.debugLine="For j=0 To 63";
{
final int step78 = 1;
final int limit78 = (int) (63);
for (_j = (int) (0) ; (step78 > 0 && _j <= limit78) || (step78 < 0 && _j >= limit78); _j = ((int)(0 + _j + step78)) ) {
 //BA.debugLineNum = 361;BA.debugLine="rBuffera(j+960)=Bit.And(rBufferp(j),0xFF)+offset";
_rbuffera[(int) (_j+960)] = (float) (anywheresoftware.b4a.keywords.Common.Bit.And((int) (_rbufferp[_j]),(int) (0xff))+_offset);
 }
};
 //BA.debugLineNum = 366;BA.debugLine="End Sub";
return "";
}
public static String  _prf(float _calculation_prf) throws Exception{
 //BA.debugLineNum = 611;BA.debugLine="Sub PRF(calculation_PRF As Float)";
 //BA.debugLineNum = 613;BA.debugLine="If calculation_PRF > 10000 Then prfc=10000";
if (_calculation_prf>10000) { 
_prfc = (float) (10000);};
 //BA.debugLineNum = 614;BA.debugLine="If calculation_PRF < 100 Then prfc=100";
if (_calculation_prf<100) { 
_prfc = (float) (100);};
 //BA.debugLineNum = 616;BA.debugLine="prfc = (1000000/calculation_PRF)/0.025";
_prfc = (float) ((1000000/(double)_calculation_prf)/(double)0.025);
 //BA.debugLineNum = 618;BA.debugLine="wBuffera(0)=Floor(prfc/65536)";
_wbuffera[(int) (0)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor(_prfc/(double)65536));
 //BA.debugLineNum = 619;BA.debugLine="wBuffera(1)=Floor((prfc-Floor(prfc/65536)*65536)/";
_wbuffera[(int) (1)] = (byte) (anywheresoftware.b4a.keywords.Common.Floor((_prfc-anywheresoftware.b4a.keywords.Common.Floor(_prfc/(double)65536)*65536)/(double)256));
 //BA.debugLineNum = 620;BA.debugLine="wBuffera(2)=prfc-Floor((prfc-Floor(prfc/65536)*65";
_wbuffera[(int) (2)] = (byte) (_prfc-anywheresoftware.b4a.keywords.Common.Floor((_prfc-anywheresoftware.b4a.keywords.Common.Floor(_prfc/(double)65536)*65536)/(double)256)*256);
 //BA.debugLineNum = 621;BA.debugLine="wBuffera(3)=8";
_wbuffera[(int) (3)] = (byte) (8);
 //BA.debugLineNum = 622;BA.debugLine="spi.WriteRead(0,wBuffera,4,4,rBufferl,1)";
_spi.WriteRead((int) (0),_wbuffera,(int) (4),(int) (4),_rbufferl,(int) (1));
 //BA.debugLineNum = 624;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 11;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 14;BA.debugLine="Dim YOYO As IOIOBT";
_yoyo = new anywheresoftware.b4a.agraham.ioio.B4AIOIOBT();
 //BA.debugLineNum = 15;BA.debugLine="Dim spi As SpiMaster";
_spi = new anywheresoftware.b4a.agraham.ioio.B4AIOIOBT.B4ASpiMasterBT();
 //BA.debugLineNum = 16;BA.debugLine="Dim slavepins() As Int";
_slavepins = new int[(int) (0)];
;
 //BA.debugLineNum = 17;BA.debugLine="slavepins = Array As Int(4, 5, 6)";
_slavepins = new int[]{(int) (4),(int) (5),(int) (6)};
 //BA.debugLineNum = 18;BA.debugLine="Dim slavemodes() As Object";
_slavemodes = new Object[(int) (0)];
{
int d0 = _slavemodes.length;
for (int i0 = 0;i0 < d0;i0++) {
_slavemodes[i0] = new Object();
}
}
;
 //BA.debugLineNum = 19;BA.debugLine="slavemodes = Array As Object( spi.OP_NORMAL, spi.";
_slavemodes = new Object[]{(Object)(_spi.OP_NORMAL),(Object)(_spi.OP_NORMAL),(Object)(_spi.OP_NORMAL)};
 //BA.debugLineNum = 20;BA.debugLine="Dim wBuffer(2000) As Byte";
_wbuffer = new byte[(int) (2000)];
;
 //BA.debugLineNum = 21;BA.debugLine="Dim rBuffer(2000) As Byte";
_rbuffer = new byte[(int) (2000)];
;
 //BA.debugLineNum = 22;BA.debugLine="Dim wBuffera(2000) As Byte";
_wbuffera = new byte[(int) (2000)];
;
 //BA.debugLineNum = 23;BA.debugLine="Dim wBuffercmd(2000) As Byte";
_wbuffercmd = new byte[(int) (2000)];
;
 //BA.debugLineNum = 24;BA.debugLine="Dim rBuffercmd(2000) As Byte";
_rbuffercmd = new byte[(int) (2000)];
;
 //BA.debugLineNum = 25;BA.debugLine="Dim rBufferb(200) As Byte";
_rbufferb = new byte[(int) (200)];
;
 //BA.debugLineNum = 26;BA.debugLine="Dim rBufferc(200) As Byte";
_rbufferc = new byte[(int) (200)];
;
 //BA.debugLineNum = 27;BA.debugLine="Dim rBufferd(200) As Byte";
_rbufferd = new byte[(int) (200)];
;
 //BA.debugLineNum = 28;BA.debugLine="Dim rBuffere(200) As Byte";
_rbuffere = new byte[(int) (200)];
;
 //BA.debugLineNum = 29;BA.debugLine="Dim rBufferf(200) As Byte";
_rbufferf = new byte[(int) (200)];
;
 //BA.debugLineNum = 30;BA.debugLine="Dim rBufferg(200) As Byte";
_rbufferg = new byte[(int) (200)];
;
 //BA.debugLineNum = 31;BA.debugLine="Dim rBufferh(200) As Byte";
_rbufferh = new byte[(int) (200)];
;
 //BA.debugLineNum = 32;BA.debugLine="Dim rBufferi(200) As Byte";
_rbufferi = new byte[(int) (200)];
;
 //BA.debugLineNum = 33;BA.debugLine="Dim rBufferj(200) As Byte";
_rbufferj = new byte[(int) (200)];
;
 //BA.debugLineNum = 34;BA.debugLine="Dim rBufferk(200) As Byte";
_rbufferk = new byte[(int) (200)];
;
 //BA.debugLineNum = 35;BA.debugLine="Dim rBufferl(200) As Byte";
_rbufferl = new byte[(int) (200)];
;
 //BA.debugLineNum = 36;BA.debugLine="Dim rBufferm(200) As Byte";
_rbufferm = new byte[(int) (200)];
;
 //BA.debugLineNum = 37;BA.debugLine="Dim rBuffern(200) As Byte";
_rbuffern = new byte[(int) (200)];
;
 //BA.debugLineNum = 38;BA.debugLine="Dim rBuffero(200) As Byte";
_rbuffero = new byte[(int) (200)];
;
 //BA.debugLineNum = 39;BA.debugLine="Dim rBufferp(200) As Byte";
_rbufferp = new byte[(int) (200)];
;
 //BA.debugLineNum = 40;BA.debugLine="Dim rBuffera(2000) As Float";
_rbuffera = new float[(int) (2000)];
;
 //BA.debugLineNum = 41;BA.debugLine="Dim i As Float";
_i = 0f;
 //BA.debugLineNum = 42;BA.debugLine="Dim timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 43;BA.debugLine="Dim hauteur_ecran_pix As Int";
_hauteur_ecran_pix = 0;
 //BA.debugLineNum = 44;BA.debugLine="Dim largeur_ecran_pix As Int";
_largeur_ecran_pix = 0;
 //BA.debugLineNum = 45;BA.debugLine="Dim Scale_ecran As Float";
_scale_ecran = 0f;
 //BA.debugLineNum = 46;BA.debugLine="Dim lv As LayoutValues";
_lv = new anywheresoftware.b4a.keywords.LayoutValues();
 //BA.debugLineNum = 47;BA.debugLine="Dim rect1 As Rect";
_rect1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.RectWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Dim origine As Int '";
_origine = 0;
 //BA.debugLineNum = 49;BA.debugLine="Dim PPGA As Int '''";
_ppga = 0;
 //BA.debugLineNum = 50;BA.debugLine="Dim PPHA As Int '''''' Variable positioning of th";
_ppha = 0;
 //BA.debugLineNum = 51;BA.debugLine="Dim HPAA As Int '''''";
_hpaa = 0;
 //BA.debugLineNum = 52;BA.debugLine="Dim LPA As Int ''''";
_lpa = 0;
 //BA.debugLineNum = 53;BA.debugLine="Dim nbpts As Float=256	'";
_nbpts = (float) (256);
 //BA.debugLineNum = 54;BA.debugLine="Dim freqnum As Float = 80	'Sampling frequency";
_freqnum = (float) (80);
 //BA.debugLineNum = 55;BA.debugLine="Dim factdilh As Float = 1 'facteur de dilation ho";
_factdilh = (float) (1);
 //BA.debugLineNum = 56;BA.debugLine="Dim sautaff As Boolean =False 'n'afficahge pas le";
_sautaff = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 57;BA.debugLine="Dim minbdtc As Float = 0.2 'min de la base de tem";
_minbdtc = (float) (0.2);
 //BA.debugLineNum = 58;BA.debugLine="Dim maxbdtc As Float = 12 'max de la base de temp";
_maxbdtc = (float) (12);
 //BA.debugLineNum = 59;BA.debugLine="Dim timer1interval As Float =30";
_timer1interval = (float) (30);
 //BA.debugLineNum = 63;BA.debugLine="Dim couleur_de_fond As Int= Colors.ARGB(255, 0, 0";
_couleur_de_fond = anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (255),(int) (0),(int) (0),(int) (40));
 //BA.debugLineNum = 64;BA.debugLine="Dim couleur_touches_1 As Int = Colors.ARGB(255, 7";
_couleur_touches_1 = anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (255),(int) (7),(int) (20),(int) (84));
 //BA.debugLineNum = 65;BA.debugLine="Dim couleur_touches_2 As Int = Colors.ARGB(255, 3";
_couleur_touches_2 = anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (255),(int) (30),(int) (53),(int) (114));
 //BA.debugLineNum = 66;BA.debugLine="Dim couleur_txt_touches As Int = Colors.yellow";
_couleur_txt_touches = anywheresoftware.b4a.keywords.Common.Colors.Yellow;
 //BA.debugLineNum = 67;BA.debugLine="Dim scaletextsize As Float = 12 'taille du texte";
_scaletextsize = (float) (12);
 //BA.debugLineNum = 68;BA.debugLine="Dim wifion As Boolean";
_wifion = false;
 //BA.debugLineNum = 71;BA.debugLine="Dim couleur_ascan As Int = Colors.green";
_couleur_ascan = anywheresoftware.b4a.keywords.Common.Colors.Green;
 //BA.debugLineNum = 72;BA.debugLine="Dim largeur_trace_ascan As Int=2dip";
_largeur_trace_ascan = anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (2));
 //BA.debugLineNum = 73;BA.debugLine="Dim position_P_gauche As Float =1'position a part";
_position_p_gauche = (float) (1);
 //BA.debugLineNum = 74;BA.debugLine="Dim position_P_haut As Float =4'2'position du hau";
_position_p_haut = (float) (4);
 //BA.debugLineNum = 75;BA.debugLine="Dim hauteur_P_ascan As Float= 91'92'hauteur du a-";
_hauteur_p_ascan = (float) (91);
 //BA.debugLineNum = 76;BA.debugLine="Dim largeur_P_ascan As Float= 74'75' largeur du a";
_largeur_p_ascan = (float) (74);
 //BA.debugLineNum = 77;BA.debugLine="Dim hf As Int =0 'hf -> 0, ascan -> 1";
_hf = (int) (0);
 //BA.debugLineNum = 81;BA.debugLine="Dim gainc As Float= 30 'gain du recepteur en dB";
_gainc = (float) (30);
 //BA.debugLineNum = 82;BA.debugLine="Dim delayc As Float = 0 'retard base de temps (µs";
_delayc = (float) (0);
 //BA.debugLineNum = 83;BA.debugLine="Dim scalec As Float = 10 'echelle de base de temp";
_scalec = (float) (10);
 //BA.debugLineNum = 84;BA.debugLine="Dim voltagec As Float = 100 'tension d'émission";
_voltagec = (float) (100);
 //BA.debugLineNum = 85;BA.debugLine="Dim tfrequencyc As Int = 4 'frequence de l'emette";
_tfrequencyc = (int) (4);
 //BA.debugLineNum = 86;BA.debugLine="Dim prfc As Float =1000 'frequence de recurrence";
_prfc = (float) (1000);
 //BA.debugLineNum = 87;BA.debugLine="Dim RT As Int = 0 'mode reflexion / transmission";
_rt = (int) (0);
 //BA.debugLineNum = 88;BA.debugLine="Dim seuil As Float = 0 'seuil du ascan";
_seuil = (float) (0);
 //BA.debugLineNum = 89;BA.debugLine="Dim filterc As Int =4	'Receiver filter";
_filterc = (int) (4);
 //BA.debugLineNum = 90;BA.debugLine="Dim answer As String";
_answer = "";
 //BA.debugLineNum = 91;BA.debugLine="Dim memtime As Long";
_memtime = 0L;
 //BA.debugLineNum = 92;BA.debugLine="Dim PRFAFF As Float=10";
_prfaff = (float) (10);
 //BA.debugLineNum = 94;BA.debugLine="Dim infocomp As Boolean=False";
_infocomp = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 96;BA.debugLine="End Sub";
return "";
}
public static String  _timer1_tick() throws Exception{
float _y = 0f;
float _x = 0f;
float _y0 = 0f;
float _x0 = 0f;
float _dy = 0f;
float _echy = 0f;
long _tempo = 0L;
int _offset = 0;
long _timejml = 0L;
float _fact_compress_h = 0f;
float _fact_compress_v = 0f;
int _c = 0;
int _nbechajeter = 0;
int _seuilp = 0;
int _seuilm = 0;
 //BA.debugLineNum = 368;BA.debugLine="Sub timer1_tick 'Background ASCAN display";
 //BA.debugLineNum = 370;BA.debugLine="Dim y As Float";
_y = 0f;
 //BA.debugLineNum = 371;BA.debugLine="Dim x As Float";
_x = 0f;
 //BA.debugLineNum = 372;BA.debugLine="Dim y0 As Float";
_y0 = 0f;
 //BA.debugLineNum = 373;BA.debugLine="Dim x0 As Float";
_x0 = 0f;
 //BA.debugLineNum = 374;BA.debugLine="Dim dy As Float";
_dy = 0f;
 //BA.debugLineNum = 375;BA.debugLine="Dim echy As Float";
_echy = 0f;
 //BA.debugLineNum = 376;BA.debugLine="Dim tempo As Long=0";
_tempo = (long) (0);
 //BA.debugLineNum = 377;BA.debugLine="Dim offset As Int =2  'offset ligne de base";
_offset = (int) (2);
 //BA.debugLineNum = 378;BA.debugLine="Dim timejml As Long";
_timejml = 0L;
 //BA.debugLineNum = 381;BA.debugLine="Activity.Invalidate";
mostCurrent._activity.Invalidate();
 //BA.debugLineNum = 383;BA.debugLine="Dim fact_compress_h As Float";
_fact_compress_h = 0f;
 //BA.debugLineNum = 384;BA.debugLine="Dim fact_compress_v As Float";
_fact_compress_v = 0f;
 //BA.debugLineNum = 385;BA.debugLine="Dim c As Int=0";
_c = (int) (0);
 //BA.debugLineNum = 387;BA.debugLine="If sautaff =True And origine<>0 Then";
if (_sautaff==anywheresoftware.b4a.keywords.Common.True && _origine!=0) { 
 //BA.debugLineNum = 388;BA.debugLine="wBuffera(0)=2";
_wbuffera[(int) (0)] = (byte) (2);
 //BA.debugLineNum = 389;BA.debugLine="spi.WriteRead(0,wBuffera,1,1,rBufferl,0)'Acquire";
_spi.WriteRead((int) (0),_wbuffera,(int) (1),(int) (1),_rbufferl,(int) (0));
 //BA.debugLineNum = 390;BA.debugLine="origine=origine-1";
_origine = (int) (_origine-1);
 //BA.debugLineNum = 391;BA.debugLine="MyGraphbt(nbpts)";
_mygraphbt((int) (_nbpts));
 //BA.debugLineNum = 392;BA.debugLine="Return";
if (true) return "";
 }else {
 //BA.debugLineNum = 394;BA.debugLine="sautaff=False";
_sautaff = anywheresoftware.b4a.keywords.Common.False;
 };
 //BA.debugLineNum = 399;BA.debugLine="wBuffera(0)=2";
_wbuffera[(int) (0)] = (byte) (2);
 //BA.debugLineNum = 400;BA.debugLine="spi.WriteRead(0,wBuffera,1,1,rBufferl,0)'Acquire";
_spi.WriteRead((int) (0),_wbuffera,(int) (1),(int) (1),_rbufferl,(int) (0));
 //BA.debugLineNum = 404;BA.debugLine="fact_compress_h= LPA/(nbpts)*factdilh";
_fact_compress_h = (float) (_lpa/(double)(_nbpts)*_factdilh);
 //BA.debugLineNum = 405;BA.debugLine="fact_compress_v=HPAA /256";
_fact_compress_v = (float) (_hpaa/(double)256);
 //BA.debugLineNum = 411;BA.debugLine="MyGraphbt(nbpts)";
_mygraphbt((int) (_nbpts));
 //BA.debugLineNum = 418;BA.debugLine="If ((rBuffera(0) =101 And rBuffera(1)=101)Or(rBuf";
if (((_rbuffera[(int) (0)]==101 && _rbuffera[(int) (1)]==101) || (_rbuffera[(int) (0)]==22 && _rbuffera[(int) (1)]==22) || (_rbuffera[(int) (0)]==12 && _rbuffera[(int) (1)]==12))) { 
 //BA.debugLineNum = 422;BA.debugLine="CanvasGraph.drawColor(couleur_de_fond)'Erase di";
mostCurrent._canvasgraph.DrawColor(_couleur_de_fond);
 //BA.debugLineNum = 423;BA.debugLine="CanvasGraph.DrawRect(rect1,Colors.black,True,1d";
mostCurrent._canvasgraph.DrawRect((android.graphics.Rect)(_rect1.getObject()),anywheresoftware.b4a.keywords.Common.Colors.Black,anywheresoftware.b4a.keywords.Common.True,(float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (1))));
 //BA.debugLineNum = 426;BA.debugLine="CanvasGraph.ClipPath(path1)";
mostCurrent._canvasgraph.ClipPath((android.graphics.Path)(mostCurrent._path1.getObject()));
 //BA.debugLineNum = 427;BA.debugLine="Dim Nbechajeter As Int =4";
_nbechajeter = (int) (4);
 //BA.debugLineNum = 428;BA.debugLine="Dim seuilp As Int=128+128*seuil/100";
_seuilp = (int) (128+128*_seuil/(double)100);
 //BA.debugLineNum = 429;BA.debugLine="Dim seuilm As Int=128-128*seuil/100";
_seuilm = (int) (128-128*_seuil/(double)100);
 //BA.debugLineNum = 432;BA.debugLine="i=0";
_i = (float) (0);
 //BA.debugLineNum = 433;BA.debugLine="x0=PPGA";
_x0 = (float) (_ppga);
 //BA.debugLineNum = 434;BA.debugLine="y0=(PPHA+HPAA)- rBuffera(Nbechajeter)*fact_com";
_y0 = (float) ((_ppha+_hpaa)-_rbuffera[_nbechajeter]*_fact_compress_v);
 //BA.debugLineNum = 435;BA.debugLine="If hf = 1 Or hf=2 Or hf=3 Then y0= (PPHA+HPAA)";
if (_hf==1 || _hf==2 || _hf==3) { 
_y0 = (float) ((_ppha+_hpaa)-(128-_rbuffera[_nbechajeter])*2*_fact_compress_v);};
 //BA.debugLineNum = 440;BA.debugLine="Do While i < LPA";
while (_i<_lpa) {
 //BA.debugLineNum = 441;BA.debugLine="i=(i+fact_compress_h)";
_i = (float) ((_i+_fact_compress_h));
 //BA.debugLineNum = 443;BA.debugLine="If seuil <>0 Then";
if (_seuil!=0) { 
 //BA.debugLineNum = 444;BA.debugLine="If rBuffera(c+Nbechajeter)> seuilp Or rBuffe";
if (_rbuffera[(int) (_c+_nbechajeter)]>_seuilp || _rbuffera[(int) (_c+_nbechajeter)]<_seuilm) { 
 //BA.debugLineNum = 445;BA.debugLine="echy=rBuffera(c+Nbechajeter)";
_echy = _rbuffera[(int) (_c+_nbechajeter)];
 }else {
 //BA.debugLineNum = 447;BA.debugLine="echy=128";
_echy = (float) (128);
 };
 }else {
 //BA.debugLineNum = 450;BA.debugLine="echy=rBuffera((c)+Nbechajeter)";
_echy = _rbuffera[(int) ((_c)+_nbechajeter)];
 };
 //BA.debugLineNum = 453;BA.debugLine="Select hf";
switch (_hf) {
case 0: {
 //BA.debugLineNum = 455;BA.debugLine="y=(PPHA+HPAA)-(echy)*fact_compress_v";
_y = (float) ((_ppha+_hpaa)-(_echy)*_fact_compress_v);
 break; }
case 1: {
 //BA.debugLineNum = 458;BA.debugLine="If rBuffera((c+Nbechajeter))<=128 Then";
if (_rbuffera[(int) ((_c+_nbechajeter))]<=128) { 
 //BA.debugLineNum = 459;BA.debugLine="y= (PPHA+HPAA)-(128-echy)*2*fact_compress_v";
_y = (float) ((_ppha+_hpaa)-(128-_echy)*2*_fact_compress_v);
 }else {
 //BA.debugLineNum = 461;BA.debugLine="y=(PPHA+HPAA)-(echy-128)*2*fact_compress_v";
_y = (float) ((_ppha+_hpaa)-(_echy-128)*2*_fact_compress_v);
 };
 break; }
case 2: {
 //BA.debugLineNum = 464;BA.debugLine="If rBuffera((i/fact_compress_h)+2)<=128 The";
if (_rbuffera[(int) ((_i/(double)_fact_compress_h)+2)]<=128) { 
 //BA.debugLineNum = 465;BA.debugLine="y= (PPHA+HPAA)-(128-rBuffera((i/fact_compre";
_y = (float) ((_ppha+_hpaa)-(128-_rbuffera[(int) ((_i/(double)_fact_compress_h)+2)])*2*_fact_compress_v);
 }else {
 //BA.debugLineNum = 467;BA.debugLine="y=(PPHA+HPAA)";
_y = (float) ((_ppha+_hpaa));
 };
 break; }
case 3: {
 //BA.debugLineNum = 470;BA.debugLine="If rBuffera((i/fact_compress_h)+2)<=128 The";
if (_rbuffera[(int) ((_i/(double)_fact_compress_h)+2)]<=128) { 
 //BA.debugLineNum = 471;BA.debugLine="y= (PPHA+HPAA)";
_y = (float) ((_ppha+_hpaa));
 }else {
 //BA.debugLineNum = 473;BA.debugLine="y=(PPHA+HPAA)-(rBuffera((i/fact_compress_h)";
_y = (float) ((_ppha+_hpaa)-(_rbuffera[(int) ((_i/(double)_fact_compress_h)+2)]-128)*2*_fact_compress_v);
 };
 break; }
}
;
 //BA.debugLineNum = 481;BA.debugLine="CanvasGraph.DrawLine(x0,y0,x0+fact_compress_";
mostCurrent._canvasgraph.DrawLine(_x0,_y0,(float) (_x0+_fact_compress_h),_y,_couleur_ascan,(float) (_largeur_trace_ascan));
 //BA.debugLineNum = 483;BA.debugLine="y0=y";
_y0 = _y;
 //BA.debugLineNum = 484;BA.debugLine="x0=(x0+fact_compress_h)";
_x0 = (float) ((_x0+_fact_compress_h));
 //BA.debugLineNum = 485;BA.debugLine="c=c+1";
_c = (int) (_c+1);
 }
;
 //BA.debugLineNum = 493;BA.debugLine="CanvasGraph.RemoveClip";
mostCurrent._canvasgraph.RemoveClip();
 //BA.debugLineNum = 495;BA.debugLine="Dim timejml As Long";
_timejml = 0L;
 //BA.debugLineNum = 496;BA.debugLine="timejml=DateTime.Now";
_timejml = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 498;BA.debugLine="If memtime-timejml <1000 Then";
if (_memtime-_timejml<1000) { 
 //BA.debugLineNum = 499;BA.debugLine="Do While timejml < memtime";
while (_timejml<_memtime) {
 //BA.debugLineNum = 500;BA.debugLine="timejml=DateTime.Now";
_timejml = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 }
;
 };
 }else {
 //BA.debugLineNum = 505;BA.debugLine="wBuffera(0)=2";
_wbuffera[(int) (0)] = (byte) (2);
 //BA.debugLineNum = 506;BA.debugLine="spi.WriteRead(0,wBuffera,1,1,rBufferl,0)'Get a";
_spi.WriteRead((int) (0),_wbuffera,(int) (1),(int) (1),_rbufferl,(int) (0));
 //BA.debugLineNum = 508;BA.debugLine="Dim timejml As Long";
_timejml = 0L;
 //BA.debugLineNum = 509;BA.debugLine="timejml=DateTime.Now";
_timejml = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 511;BA.debugLine="If memtime-timejml <1000 Then";
if (_memtime-_timejml<1000) { 
 //BA.debugLineNum = 512;BA.debugLine="Do While timejml < memtime";
while (_timejml<_memtime) {
 //BA.debugLineNum = 513;BA.debugLine="timejml=DateTime.Now";
_timejml = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 }
;
 };
 //BA.debugLineNum = 516;BA.debugLine="sautaff=True";
_sautaff = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 517;BA.debugLine="origine=2";
_origine = (int) (2);
 };
 //BA.debugLineNum = 522;BA.debugLine="memtime=DateTime.now+1/PRFAFF*1000";
_memtime = (long) (anywheresoftware.b4a.keywords.Common.DateTime.getNow()+1/(double)_prfaff*1000);
 //BA.debugLineNum = 524;BA.debugLine="End Sub";
return "";
}
public static String  _transmission_mode(int _rtc) throws Exception{
 //BA.debugLineNum = 625;BA.debugLine="Sub Transmission_mode(RTC As Int)";
 //BA.debugLineNum = 627;BA.debugLine="wBuffera(0)= RTC";
_wbuffera[(int) (0)] = (byte) (_rtc);
 //BA.debugLineNum = 628;BA.debugLine="wBuffera(1)=9";
_wbuffera[(int) (1)] = (byte) (9);
 //BA.debugLineNum = 629;BA.debugLine="spi.WriteRead(0,wBuffera,2,2,rBufferl,1)";
_spi.WriteRead((int) (0),_wbuffera,(int) (2),(int) (2),_rbufferl,(int) (1));
 //BA.debugLineNum = 631;BA.debugLine="End Sub";
return "";
}
public static String  _transmitter_frequency(int _calculation_frequency) throws Exception{
int _nb = 0;
 //BA.debugLineNum = 594;BA.debugLine="Sub Transmitter_frequency(calculation_frequency As";
 //BA.debugLineNum = 596;BA.debugLine="Dim nb As Int";
_nb = 0;
 //BA.debugLineNum = 597;BA.debugLine="If calculation_frequency < 1 Then calculation_fre";
if (_calculation_frequency<1) { 
_calculation_frequency = (int) (1);};
 //BA.debugLineNum = 598;BA.debugLine="If calculation_frequency > 20 Then calculation_fr";
if (_calculation_frequency>20) { 
_calculation_frequency = (int) (20);};
 //BA.debugLineNum = 599;BA.debugLine="tfrequencyc=calculation_frequency";
_tfrequencyc = _calculation_frequency;
 //BA.debugLineNum = 600;BA.debugLine="If calculation_frequency <=20 And calculation_fre";
if (_calculation_frequency<=20 && _calculation_frequency>15) { 
_nb = (int) (2);};
 //BA.debugLineNum = 601;BA.debugLine="If calculation_frequency <=15 And calculation_fre";
if (_calculation_frequency<=15 && _calculation_frequency>12) { 
_nb = (int) (3);};
 //BA.debugLineNum = 602;BA.debugLine="If calculation_frequency <=12 And calculation_fre";
if (_calculation_frequency<=12 && _calculation_frequency>9) { 
_nb = (int) (4);};
 //BA.debugLineNum = 603;BA.debugLine="If calculation_frequency <=9 And calculation_freq";
if (_calculation_frequency<=9 && _calculation_frequency>7.5) { 
_nb = (int) (5);};
 //BA.debugLineNum = 604;BA.debugLine="If calculation_frequency <= 7.5 Then nb= (1000/(2";
if (_calculation_frequency<=7.5) { 
_nb = (int) ((1000/(double)(2*_calculation_frequency)-27)/(double)6.5);};
 //BA.debugLineNum = 606;BA.debugLine="wBuffera(0)=nb";
_wbuffera[(int) (0)] = (byte) (_nb);
 //BA.debugLineNum = 607;BA.debugLine="wBuffera(1)=7";
_wbuffera[(int) (1)] = (byte) (7);
 //BA.debugLineNum = 608;BA.debugLine="spi.WriteRead(0,wBuffera,2,2,rBufferl,1)";
_spi.WriteRead((int) (0),_wbuffera,(int) (2),(int) (2),_rbufferl,(int) (1));
 //BA.debugLineNum = 610;BA.debugLine="End Sub";
return "";
}
public static String  _transmitter_voltage(float _calculation_voltage) throws Exception{
float _rep0 = 0f;
float _rep1 = 0f;
 //BA.debugLineNum = 581;BA.debugLine="Sub Transmitter_voltage(calculation_voltage As Flo";
 //BA.debugLineNum = 582;BA.debugLine="Dim rep0 As Float=0";
_rep0 = (float) (0);
 //BA.debugLineNum = 583;BA.debugLine="Dim rep1 As Float=0";
_rep1 = (float) (0);
 //BA.debugLineNum = 585;BA.debugLine="If calculation_voltage > 250 Then voltagec = 250";
if (_calculation_voltage>250) { 
_voltagec = (float) (250);};
 //BA.debugLineNum = 587;BA.debugLine="If calculation_voltage < 10 Then voltagec = 10	'M";
if (_calculation_voltage<10) { 
_voltagec = (float) (10);};
 //BA.debugLineNum = 589;BA.debugLine="wBuffera(0)=voltagec*(98/180)+81.7";
_wbuffera[(int) (0)] = (byte) (_voltagec*(98/(double)180)+81.7);
 //BA.debugLineNum = 590;BA.debugLine="wBuffera(1)=6";
_wbuffera[(int) (1)] = (byte) (6);
 //BA.debugLineNum = 591;BA.debugLine="spi.WriteRead(0,wBuffera,2,2,rBufferl,1)";
_spi.WriteRead((int) (0),_wbuffera,(int) (2),(int) (2),_rbufferl,(int) (1));
 //BA.debugLineNum = 593;BA.debugLine="End Sub";
return "";
}
}
