package com.user_example_injava;
import android.os.Bundle;
import android.content.Context;
import android.view.Display;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.Toast;
import android.widget.Button;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.ArrayAdapter;
import android.graphics.*;
import android.net.wifi.WifiManager;
import ioio.lib.api.DigitalInput;
import ioio.lib.api.DigitalOutput;
import ioio.lib.api.AnalogInput;////////////
import ioio.lib.api.SpiMaster;///////////////////////
import ioio.lib.api.exception.ConnectionLostException;//
import ioio.lib.util.BaseIOIOLooper;////////////////////
import ioio.lib.util.IOIOLooper;////////////////////////
import ioio.lib.util.android.IOIOActivity;//////////////
import java.lang.CharSequence;

public class LayoutMainActivity extends IOIOActivity{ // implements OnClickListener {

	/* Initialisation Globale */
	Button button1;//Display and transmission mode
	Button button2;//Scale and Gain
	Button button3;//Sampling Delay
	Button button4;//Transmitter Frequency and Voltage
	Button button5;//PRF
	Button button6;//Filters
	Button kbvalide;//button to confirm the parameters entered by the keyboard
	
	TextView lbkb;//label of Edit text
	EditText answerkb ;// for enter parametre by keyboard
	TextView affTexte;//
	
	ImageView view1;/*Display Graph Zone*/
	Bitmap bitmap;/**/
	Canvas canvas;/*For trace the signal*/
	Paint paint;/**/
	
	WifiManager wifiManager;//For disable wifi ( create interference if wifi is on )
	
	/* buffers is for read / write data from bluetooth */
	public static byte[] wbuffer = new byte[2000];//
	public static byte[] rbuffer = new byte[2000];//
	public static byte[] wbuffera = new byte[2000];//
	public static byte[] wbuffercmd = new byte[2000];//
	public static byte[] rbuffercmd = new byte[2000];//
	public static byte[] rbufferb = new byte[200];//
	public static byte[] rbufferc = new byte[200];//
	public static byte[] rbufferd = new byte[200];//
	public static byte[] rbuffere = new byte[200];//
	public static byte[] rbufferf = new byte[200];//
	public static byte[] rbufferg = new byte[200];//
	public static byte[] rbufferh = new byte[200];// 
	public static byte[] rbufferi = new byte[200];//
	public static byte[] rbufferj = new byte[200];//
	public static byte[] rbufferk = new byte[200];//
	public static byte[] rbufferl = new byte[200];//
	public static byte[] rbufferm = new byte[200];//
	public static byte[] rbuffern = new byte[200];//
	public static byte[] rbuffero = new byte[200];//
	public static byte[] rbufferp = new byte[200];//
	public static float[] rbuffera = new float[2000];//
	/* **************************************************************** */
	
	public static int hauteur_ecran=0;// initialize display height
	public static int largeur_ecran=0;// initialize display width
	
	public static int nbpts = 256;// number of point per sample displayed
	public static float freqnum = 80;// sampling frequency in MHz
	public static float factdilh=0;// horizontal expansion factor
	public static float minbdtc = 1;// limit mini of time base
	public static float maxbdtc = 20;// limit maxi of time base 
		
	public static int hf = 0;// default graphe display in HF =0 and ASCAN = 1
	public static float gainc = 20;// default gain in dB
	public static float delayc = 0;// default display delay
	public static float scalec = 5;// default scale in s
	public static float voltagec = 150;// default transmitter voltage in volt
	public static int tfrequencyc = 4;// default transmitter frequency in MHz
	public static float prfc = 1000;// default recurrence frequency in Hz
	public static int rt = 0;// default Reflection / Transmission mode ( reflection =0 / transmission = 1)
	public static float seuil = 0;// ASCAN threshold default value
	public static int filterc = 4;// default filter ( 0 = 1.25 MHz, 1 = 2.5 MHz, 2 = 5 MHz ,3 = 10 MHz, 4 = BROADBAND )
	public static int parametre_number=0;// for set the value entering in keyboard to the right parameters
	public static float echascanc = 8000; // Sampling window (not to change)
	public static float i;
	
	/* Variable for the tracing the graph ( not to change ) 	*/
	float x0=0 ;//
	float y0=0 ;//
	float x=0 ;//
	float y=0 ;//
	float echy=0;//
	int Nbechajeter =4;//
	int seuilp=0;//
	int seuilm=0;//
 	float fact_comp_v=0;//
	float fact_comp_h=0;//
	int c=0;//
	/* ***************************************************************** */
	/* Initialization of variable for SPI communication between US componante and communication module */
	public int pos=0;
	private static final Object[] from = null;
	public int compteur=0;
	public SpiMaster spi;
	public static Object[] _slavemodes=new Object[] { (Object) (DigitalOutput.Spec.Mode.NORMAL),
		(Object) (DigitalOutput.Spec.Mode.NORMAL), (Object) (DigitalOutput.Spec.Mode.NORMAL) };
	/* ****************************************************************** */	
	boolean inter_bouton=false;
	
	@Override
	public void onCreate(Bundle savedInstanceState){ //Statement objects used
		super.onCreate(savedInstanceState);
		
		//Remove title bar
		this.requestWindowFeature(android.view.Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_layout_main);
		
		Display ecran = getWindowManager().getDefaultDisplay();
		Point size = new Point();
		ecran.getSize(size);
		
		hauteur_ecran=size.y;
		largeur_ecran=size.x;
				
		view1=(ImageView)this.findViewById(R.id.view1);
				
		bitmap=Bitmap.createBitmap((int) getWindowManager()
		        .getDefaultDisplay().getWidth(), (int) getWindowManager()
		        .getDefaultDisplay().getHeight(), Bitmap.Config.ARGB_8888);
		
		canvas = new Canvas(bitmap);
	    view1.setImageBitmap(bitmap);
							
	    paint = new Paint();
	    paint.setColor(Color.GREEN);
	    paint.setStrokeWidth(3);
	
		button1=(Button) findViewById(R.id.button1);
		button1.setOnClickListener(new ButtonClick());

		button2=(Button) findViewById(R.id.button2);
		button2.setOnClickListener(new ButtonClick());
		
		button3=(Button) findViewById(R.id.button3);
		button3.setOnClickListener(new ButtonClick());
		
		button4=(Button) findViewById(R.id.button4);
		button4.setOnClickListener(new ButtonClick());
		
		button5=(Button) findViewById(R.id.button5);
		button5.setOnClickListener(new ButtonClick());
		
		button6=(Button) findViewById(R.id.button6);
		button6.setOnClickListener(new ButtonClick());
		
		kbvalide=(Button)findViewById(R.id.kbvalide);
		kbvalide.setOnClickListener(new ButtonClick());
		
		lbkb =(TextView)findViewById(R.id.lbkb);
		answerkb =(EditText)findViewById(R.id.answerkb);
		
		affTexte=(TextView) findViewById(R.id.affTexte);
			    
	    wifiManager = (WifiManager) this.getSystemService(Context.WIFI_SERVICE); 	
	    
		enableUi(false);
	}
	/* ********************************************************************* */	
	class Looper extends BaseIOIOLooper { //communication loop with bluetooth and US componant
		private AnalogInput in;
		
		static final int misoPin = 10;
		static final int mosiPin = 11;			// assignment spi communication port
		static final int clkPin = 12;
		int[] ssPins = new int[] { 4, 5, 6 };
		int ssPin = 4;
		
		/* Set the SPI communication ( between Us componant and bluetooth ) , */ 
		public SpiMaster OpenSpiMaster(int paramInt1, DigitalInput.Spec.Mode paramMode, int paramInt2, DigitalOutput.Spec.Mode paramMode1, int paramInt3, DigitalOutput.Spec.Mode paramMode2, int[] paramArrayOfInt, Object[] paramArrayOfObject, SpiMaster.Rate paramRate, boolean paramBoolean1, boolean paramBoolean2)
			    throws ConnectionLostException
			  {
			    DigitalInput.Spec localSpec = new DigitalInput.Spec(paramInt1, paramMode);
			    DigitalOutput.Spec localSpec1 = new DigitalOutput.Spec(paramInt2, paramMode1);
			    DigitalOutput.Spec localSpec2 = new DigitalOutput.Spec(paramInt3, paramMode2);
			    DigitalOutput.Spec[] arrayOfSpec = new DigitalOutput.Spec[paramArrayOfInt.length];
			    for (int i = 0; ; i++)
			    {
			      if (i >= arrayOfSpec.length)
			      {
			        SpiMaster.Config localConfig = new SpiMaster.Config(paramRate, paramBoolean1, paramBoolean2);
			        return this.ioio_.openSpiMaster(localSpec, localSpec1, localSpec2, arrayOfSpec, localConfig);
			      }
			      arrayOfSpec[i] = new DigitalOutput.Spec(paramArrayOfInt[i], (DigitalOutput.Spec.Mode)paramArrayOfObject[i]);
			    }
			  }	
		/* ************************************************ */ 
		protected void setup() throws ConnectionLostException, InterruptedException { //
			
			in = ioio_.openAnalogInput(33);//Port initialization for measuring the battery voltage
			
			//Set SPI comm
			spi = OpenSpiMaster (misoPin,DigitalInput.Spec.Mode.PULL_UP,mosiPin,DigitalOutput.Spec.Mode.NORMAL,clkPin,DigitalOutput.Spec.Mode.NORMAL,ssPins, _slavemodes,SpiMaster.Rate.RATE_333K,false,true);				
												
			initUs();// Calling the sub sending initialization conf
			
			enableUi(true);// Activating the timer Soft
			
			wifiManager.setWifiEnabled(false); // disable wifi
			
			// sends the number of points for automatic sampling launch
			wbuffercmd[0] = (byte) (Math.floor((double)(nbpts /256)));
			
			wbuffercmd[1] = (byte) ((int)nbpts - (Math.floor((double)(nbpts/256)))*256);
			
			wbuffercmd[2] = (byte) 4;
			
			spi.writeRead(0, wbuffercmd, 3, 3,rbuffercmd, 0);
			/* ************************************************* */			
		}
				
		public void loop() throws ConnectionLostException, InterruptedException { // Loop Timer Soft
			
			//Acquire a new sample
			wbuffera[0] = (byte) 2;
			spi.writeRead(0, wbuffera, 1, 1, rbufferl,1);
					
			getSamples((int)nbpts);
			
			Thread.sleep(100);
			
			drawAscan(inter_bouton);
			
			setNumber(in.read());
			
		}
		
		public void disconnected() {
			enableUi(false);
			//wifiManager.setWifiEnabled(true);
			Toast.makeText(getApplicationContext(),"IOIO disconnected",Toast.LENGTH_SHORT).show();
		}	
	}
	
	protected IOIOLooper createIOIOLooper() {
		return new Looper();
	}
	
	public void enableUi(final boolean enable) {
		runOnUiThread(new Runnable() {			
			public void run() {	
			}
		});
	}
	/* display battery voltage */ 	
	private void setNumber(float f) {
		final String str = String.format("%.2f", f*13.3);
		runOnUiThread(new Runnable() {
			@Override
			public void run() {
				affTexte.setText(str+" V"); 
			}
		});
	}
	/* *********************************************** */ 
	
	/* setup Initialization */
	public void initUs() throws ConnectionLostException, InterruptedException {
		
		dac((int) (1), (int) (0));

		prf(prfc);

		gain(gainc);

		delay(delayc);

		display_scale(scalec);

		transmitter_voltage(voltagec);

		transmitter_frequency(tfrequencyc);

		transmission_mode(rt);

		echascan(echascanc);

		echostart((float) 0, (float) 10000, (int) 50);

		filter(filterc);
						
	}
	/* ********************************************************************* */
	/* Get sampling */
	public void getSamples(final int nbech) throws ConnectionLostException, InterruptedException {
		
		runOnUiThread(new Runnable() {
			@Override
			public void run() {
				int offset = 2;
				
				try {
					spi.writeRead(1,wbuffer,0,64,rbuffer,64);
				} catch (Exception e) {
				}
				for (int j = 0; j <= 63; j++) 
				{	
					rbuffera[j]=(((int) rbuffer[j]) & 0xff) + offset;
				}
				if(nbech==64){return;}
				
				try{
					spi.writeRead(1,wbuffer,0,64,rbuffer,64);
				}catch (Exception e){}
				for (int j=0;j<=63;j++)
				{
					rbuffera[j+64]=(((int) rbuffer[j]) & 0xff) + offset;
				}
				if(nbech==128){return;}
				
				try{
					spi.writeRead(1,wbuffer,0,64,rbuffer,64);
				}catch (Exception e){}
				for (int j=0;j<=63;j++)
				{
					rbuffera[j+128]=(((int) rbuffer[j]) & 0xff) + offset;
				}
				if(nbech==192){return;}
				
				try{
					spi.writeRead(1,wbuffer,0,64,rbuffer,64);
				}catch (Exception e){}
				for (int j=0;j<=63;j++)
				{
					rbuffera[j+192]=(((int) rbuffer[j]) & 0xff) + offset;
				}
				if(nbech==256){return;}
		
			}
		});
	}
	/* ******************************************************************** */
	/* Draw ASCAN */
	public void drawAscan(final boolean trace) throws ConnectionLostException, InterruptedException {	
		runOnUiThread(new Runnable() {
			@Override
			public void run() {		
		x0=0;
		y0=0;
		x=0;
		y=0;
		echy=0;
		i=0;
		c=0;		
		
	     
				if(trace==false){
					if(view1.isShown()!=true){view1.setVisibility(View.VISIBLE);}
					
				if((rbuffera[0]==12&&rbuffera[1]==12)||(rbuffera[0]==22&&rbuffera[1]==22)||(rbuffera[0]==101&&rbuffera[1]==101)){	
					
					canvas.drawColor(Color.BLACK);
					
					seuilp=(int)(128+128*seuil/100);
					seuilm=(int)(128-128*seuil/100);
					
				 	fact_comp_v=(float)((hauteur_ecran/255)+0.2);
					fact_comp_h=(float)(((float)(largeur_ecran/(float)(nbpts-5)))*factdilh);
					
					y0=(float)(hauteur_ecran-(rbuffera[Nbechajeter]*fact_comp_v));
					if (hf==1){y0=hauteur_ecran-((128-rbuffera[Nbechajeter])*2*fact_comp_v);}	
					
				while (i<(largeur_ecran))				
				{
					i=(float)(i+fact_comp_h);
					if(seuil!=0){
						if ((rbuffera[c+Nbechajeter]>seuilp)||(rbuffera[c+Nbechajeter]<seuilm)){
							echy=(float)(rbuffera[c+Nbechajeter]);}
						else{
							echy=128;}
					;}
					else{
						echy=(float)(rbuffera[c+Nbechajeter]);}
					
					switch(hf){
						case 0:{
							y=(float)(hauteur_ecran-(echy*fact_comp_v));break;
						}
						case 1:{
							if (rbuffera[c+Nbechajeter]<=128){
								y=(float)(hauteur_ecran-(128-echy)*2*fact_comp_v);}
							else{
								y=(float)(hauteur_ecran-(echy-128)*2*fact_comp_v);}
							break;
						}
					}
					canvas.drawLine(x0,y0,x0+fact_comp_h,y, paint);
					y0=y;
					x0=(x0+fact_comp_h);
					c=c+1;
				};
				;}else{//Acquire a new sample
					wbuffera[0] = (byte) 2;
					try {
						spi.writeRead(0, wbuffera, 1, 1, rbufferl,1);
					} catch (Exception e){};} 
																
			;}else{if(view1.isShown()==true){view1.setVisibility(View.GONE);};}		    				
			}
	
		});
	    
	}
	/* ******************************************************************** */
			
	public class ButtonClick implements View.OnClickListener { //Button Clicks handling routine
		String lbhf,lbrt,lbfilter=null;
		
		public void onClick(final View view) {
			
			runOnUiThread(new Runnable() {			
				public void run() {	
					inter_bouton=true;	
					switch(view.getId()){
		
					case R.id.button1:{
																		
						if (hf==0){lbhf="(change to ASCAN)";}else{lbhf="(change to HF)";}
						if (rt==0){lbrt="(change to Transmission)";}else{lbrt="(change to Reflection)";}
							
						String[]from={"Display type "+lbhf,"Transmission mode "+lbrt};
						final ListView listView;
						ArrayAdapter arrayAdapter;
						listView=(ListView) findViewById(R.id.zone_list);
						listView.setVisibility(View.VISIBLE);
						arrayAdapter=new ArrayAdapter(getApplicationContext(),R.layout.setlist,R.id.paraList,from);
						listView.setAdapter(arrayAdapter);
						listView.setOnItemClickListener(new OnItemClickListener()
						{
							 public void onItemClick(AdapterView<?> parent, View view,int position, long id) {
								 listView.setVisibility(View.GONE);
								 
								 switch(position){
								 
									 case 0:{
										 if (hf==0){hf=1;lbhf="ASCAN";}else{hf=0;lbrt="HF";}
										 Toast.makeText(getApplicationContext(),"Display Type "+lbhf,Toast.LENGTH_SHORT).show();
										 inter_bouton=false;break;
									 }
									 
									 case 1:{
										 if (rt==0){rt=1;lbrt="Transmission";}else{rt=0;lbrt="Reflection";}
											try {
												transmission_mode(rt);
											} catch (Exception e) {
											}								
										 Toast.makeText(getApplicationContext(),"Transmission mode "+lbrt,Toast.LENGTH_SHORT).show();
										 inter_bouton=false;break;
									 }
								 } 
							 }	
						});	
						
						break;
					}
					
					case R.id.button2:{
						
						String[]from={"Display scale","Gain"};
						final ListView listView;
						ArrayAdapter arrayAdapter;
						listView=(ListView) findViewById(R.id.zone_list);
						listView.setVisibility(View.VISIBLE);
						arrayAdapter=new ArrayAdapter(getApplicationContext(),R.layout.setlist,R.id.paraList,from);
						listView.setAdapter(arrayAdapter);
						listView.setOnItemClickListener(new OnItemClickListener()
						{
							public void onItemClick(AdapterView<?> parent, View view,int position, long id) {
								listView.setVisibility(View.GONE);
								
								switch(position){
								 
								 case 0:{
									parametre_number=1;
									KeyboardAnswer("Set value of display scale");
									break;
								 }
								 
								 case 1:{
									 parametre_number=2;
									 KeyboardAnswer("Set gain value");
									 break;
								 }
							 }
							 }	
						});
						break;
					}
					case R.id.button3:{
						parametre_number=3;
						KeyboardAnswer("Set sampling delay value");
						break;
					}
					case R.id.button4:{
						
						String[]from={"Transmitter frequency","Transmitter voltage"};
						final ListView listView;
						ArrayAdapter arrayAdapter;
						listView=(ListView) findViewById(R.id.zone_list);
						listView.setVisibility(View.VISIBLE);
						arrayAdapter=new ArrayAdapter(getApplicationContext(),R.layout.setlist,R.id.paraList,from);
						listView.setAdapter(arrayAdapter);
						listView.setOnItemClickListener(new OnItemClickListener()
						{
							 public void onItemClick(AdapterView<?> parent, View view,int position, long id) {
								 listView.setVisibility(View.GONE);	 
								 
								 switch (position){
								 
								 case 0:{
									 parametre_number=4;
									 KeyboardAnswer("Set Transmitter frequency value");
								 break;}
								 
								 case 1:{
									 parametre_number=5;
									 KeyboardAnswer("Set transmitter voltage value");
								 break;}
								 }
							}	
						});
						break;
					}
					case R.id.button5:{
						parametre_number=6;
						KeyboardAnswer("Set PRF value");     
						break;}
					
					case R.id.button6:{
										
						String[]from={"1.25 MHz","2.5 MHz","5 MHz","10 MHz","BROADBAND"};
						final ListView listView;
						ArrayAdapter arrayAdapter;
						listView=(ListView) findViewById(R.id.zone_list);
						listView.setVisibility(View.VISIBLE);
						arrayAdapter=new ArrayAdapter(getApplicationContext(),R.layout.setlist,R.id.paraList,from);
						listView.setAdapter(arrayAdapter);
						listView.setOnItemClickListener(new OnItemClickListener()
						{
							 public void onItemClick(AdapterView<?> parent, View view,int position, long id) {
								 listView.setVisibility(View.GONE);
								 filterc=position;
								 if (filterc==0){lbfilter="1.25 MHz";}
								 if (filterc==1){lbfilter="2.5 MHz";}
								 if (filterc==2){lbfilter="5 MHz";}
								 if (filterc==3){lbfilter="10 MHz";}
								 if (filterc==4){lbfilter="BROADBAND";}
								 try {
									filter(filterc);
								}catch (Exception e) {
								} inter_bouton=false;
								 Toast.makeText(getApplicationContext(),"Selected filter "+lbfilter,Toast.LENGTH_SHORT).show(); 					
							 }
						});
						
						break;
					}
					
					case R.id.kbvalide:{
						
						switch(parametre_number){
							case 1:{
								scalec=Float.parseFloat(answerkb.getText().toString());
								 Toast.makeText(getApplicationContext(),"Scale: "+scalec,Toast.LENGTH_SHORT).show();
							try {
								display_scale(scalec);
							} catch (Exception e) {
							}inter_bouton=false; break;}
							
							case 2:{
								gainc=Float.parseFloat(answerkb.getText().toString());
								 Toast.makeText(getApplicationContext(),"Gain: "+gainc,Toast.LENGTH_SHORT).show();
							try {
								gain(gainc);
							} catch (Exception e) {
							}inter_bouton=false;break;}
							
							case 3:{
								delayc=Float.parseFloat(answerkb.getText().toString());		
								 Toast.makeText(getApplicationContext(),"Delay: "+delayc,Toast.LENGTH_SHORT).show();
							try {
								delay(delayc);
							} catch (Exception e) {
							}inter_bouton=false;break;}
							
							case 4:{
								tfrequencyc=Integer.parseInt(answerkb.getText().toString());
								 Toast.makeText(getApplicationContext(),"Transmitter frequency: "+tfrequencyc,Toast.LENGTH_SHORT).show();
							try {
								transmitter_frequency(tfrequencyc);
							} catch (Exception e) {
							}inter_bouton=false;break;}
							
							case 5:{
								voltagec=Float.parseFloat(answerkb.getText().toString());	
								 Toast.makeText(getApplicationContext(),"Transmitter voltage: "+voltagec,Toast.LENGTH_SHORT).show();
								try {
									transmitter_voltage(voltagec);
								} catch (Exception e) {
								}inter_bouton=false;break;}
							
							case 6:{
								prfc=Float.parseFloat(answerkb.getText().toString());		
								 Toast.makeText(getApplicationContext(),"PRF: "+prfc,Toast.LENGTH_SHORT).show();
							try {
								prf(prfc);
							} catch (Exception e) {
							}inter_bouton=false;break;}
						}
						
						parametre_number=0;
						answerkb.setText("");
						answerkb.setVisibility(View.GONE);
						lbkb.setVisibility(View.GONE);
						kbvalide.setVisibility(View.GONE);
					}
				}
			}
		});	
	}
}	
	/* ******************************************************************** */
	
	/* Sending command parameters */
public void dac(int madac, int progdac) throws ConnectionLostException, InterruptedException {
		
		wbuffera[0] = (byte) (madac + progdac * 2);
		
		wbuffera[1] = (byte) 11;
		
		spi.writeRead(0, wbuffera, 2, 2, rbufferl,1);
	}
	
public void delay(float calculation_delay) throws ConnectionLostException, InterruptedException {
		
		if (delayc < 0) {
			delayc = (float) (0);
		}
		;
		
		calculation_delay = (float) (delayc / (double) 0.025);
		
		wbuffercmd[0] = (byte) Math.floor(calculation_delay / (double) 256);
		
		wbuffercmd[1] = (byte) (calculation_delay - Math.floor(calculation_delay / (double) 256) * 256);
		
		wbuffercmd[2] = (byte) 5;
		
		spi.writeRead(0, wbuffercmd, 3, 3,rbuffercmd, 1);
	}

public void display_scale(float calculation_scale)throws ConnectionLostException, InterruptedException {
			
		final float nbechant;
		final float c;
		final float d;
		final float e;
		
		if (calculation_scale < minbdtc) {
			scalec = minbdtc;
		}
		;
		
		if (calculation_scale > maxbdtc) {
			scalec = maxbdtc;
		}
		;
		
		
		nbechant = (scalec * 10 * freqnum);
				
		c = (float) (nbechant / (nbpts-4));
				
		d = (float) (Math.floor(c));
		
		factcomp((int) (d));
		
		factdilh = (float) (((d + 1) / freqnum * (nbpts-4)) /  (scalec * 10));
		
		wbuffera[0] = (byte) 2;
		
		spi.writeRead(0, wbuffera,1,1, rbufferl,0);
							
	}

public void echascan(float consechascan) throws ConnectionLostException, InterruptedException {
		
		wbuffercmd[0] = (byte) Math.floor((double)(consechascan/256));
		
		wbuffercmd[1] = (byte) (consechascan - Math.floor((double)(consechascan/256))*256);
		
		wbuffercmd[2] = (byte) 10;
		
		spi.writeRead(0, wbuffercmd, 3, 3,rbuffercmd, 1);
	}

public void echostart(float pos, float duree, int polarite)throws ConnectionLostException, InterruptedException {
			
		
		wbuffera[0] = (byte) (Math.floor((double)(duree /256)));
		
		wbuffera[1] = (byte) (duree - Math.floor((double)(duree / 256)) * 256);
		
		wbuffera[2] = (byte) (Math.floor((double)(pos /  256)));
		
		wbuffera[3] = (byte) (pos - Math.floor((double)(pos / 256) )* 256);
		
		wbuffera[4] = (byte) 12;
		
		spi.writeRead(0, wbuffera,5,5, rbufferl,1);		
		
		wbuffera[0] = (byte) polarite;
		
		wbuffera[1] = (byte) 13;
		
		spi.writeRead(0, wbuffera, 2, 2, rbufferl,1);
	}

public void factcomp(int consfactcomp) throws ConnectionLostException, InterruptedException {
		
		wbuffera[0] = (byte) consfactcomp;
		
		wbuffera[1] = (byte) 3;
		
		spi.writeRead(0, wbuffera,2,2, rbufferl,1);
		
	}

public void filter(int cfilterc) throws ConnectionLostException, InterruptedException {
		
		wbuffercmd[0] = (byte) cfilterc;
		
		wbuffercmd[1] = (byte) 14;
		
		spi.writeRead(0, wbuffercmd, 2, 2,rbuffercmd,1);

	}

public void gain(float calculation_gain) throws ConnectionLostException, InterruptedException {
		
		if (gainc > 80) {
			gainc = (float) 80;
		}
		;
		
		if (gainc < 0) {
			gainc = (float) 0;
		}
		;
		
		calculation_gain = (float) (gainc * (875 - 65) / (double) 80 + 65);
		
		wbuffercmd[0] = (byte) (Math.floor(calculation_gain / (double) 256));
					
		wbuffercmd[1] = (byte) (calculation_gain - Math.floor(calculation_gain / (double) 256) * 256);
		
		wbuffercmd[2] = (byte) 0;

		spi.writeRead(0, wbuffercmd, 3, 3,rbuffercmd,1);
		
	}
	
public void prf(float calculation_prf) throws ConnectionLostException, InterruptedException {
		
		if (calculation_prf > 10000) {
			prfc = (float) (10000);
		}
		;
		
		if (calculation_prf < 100) {
			prfc = (float) (100);
		}
		;
		
		prfc = (float) ((1000000 / (double) calculation_prf) / (double) 0.025);
		
		wbuffera[0] = (byte) (Math.floor(prfc / (double) 65536));
		
		wbuffera[1] = (byte) (Math.floor((prfc - Math.floor(prfc / (double) 65536) * 65536) / (double) 256));
		
		wbuffera[2] = (byte) (prfc - Math.floor((prfc - Math.floor(prfc / (double) 65536) * 65536) / (double) 256) * 256);
		
		wbuffera[3] = (byte) 8;
		
		spi.writeRead(0, wbuffera, 4, 4, rbufferl,1);
		
	}
	
public void transmission_mode(int RTC) throws ConnectionLostException, InterruptedException {
		
		wbuffer[0] = (byte) RTC;
		wbuffer[1] = (byte) 9;
		
		spi.writeRead(0, wbuffer, 2, 2, rbuffer,1);
		
	}
	
public void transmitter_frequency(int calculation_frequency)throws ConnectionLostException, InterruptedException {
		int nb = 0;
		
		nb = 0;
		
		if (calculation_frequency < 1) {
			calculation_frequency = (int) (1);
		}
		;
		
		if (calculation_frequency > 20) {
			calculation_frequency = (int) (20);
		}
		;
		
		tfrequencyc = calculation_frequency;
		
		if (calculation_frequency <= 20 && calculation_frequency > 15) {
			nb = (int) (2);
		}
		;
		
		if (calculation_frequency <= 15 && calculation_frequency > 12) {
			nb = (int) (3);
		}
		;
		
		if (calculation_frequency <= 12 && calculation_frequency > 9) {
			nb = (int) (4);
		}
		;
		
		if (calculation_frequency <= 9 && calculation_frequency > 7.5) {
			nb = (int) (5);
		}
		;
		
		if (calculation_frequency <= 7.5) {
			nb = (int) ((1000 / (double) (2 * calculation_frequency) - 27) / (double) 6.5);
		}
		;
		
		wbuffera[0] = (byte) nb;
		
		wbuffera[1] = (byte) 7;
		
		spi.writeRead(0, wbuffera, 2, 2, rbufferl,1);

	}

public void transmitter_voltage(float calculation_voltage)throws ConnectionLostException, InterruptedException {
				
		if (calculation_voltage > 250) {
			voltagec = (float) (250);
		}
		;
		
		if (calculation_voltage < 10) {
			voltagec = (float) (10);
		}
		;
		
		wbuffera[0] = (byte) (voltagec * (98 / (double) 180) + 81.7);
		
		wbuffera[1] = (byte) 6;
		
		spi.writeRead(0, wbuffera,2,2,rbufferl,1);
		
	}
	
public void KeyboardAnswer(CharSequence lbkbtxt) {
				
		lbkb.setText(lbkbtxt);
		answerkb.setVisibility(View.VISIBLE);
		lbkb.setVisibility(View.VISIBLE);
		kbvalide.setVisibility(View.VISIBLE);					
	}
	
}
